      program Rmsmod
 
c     Pour un ensemble de vecteurs CERFACS.
c     Extraction d'un mode pour impression: norme=f(numero atome)
c
c     A FAIRE: tester les masses en entree.
c
c     YHS-Jan-1997: Premiere version.
c     YHS-Jan-2002: Dernieres modifications.
 
      implicit none
      integer nvecmx, natmax, nresmx, nmotsmax
      parameter(natmax=10000,nvecmx=50,nresmx=natmax,nmotsmax=1000)
      integer fatres(nresmx), i,  iat, ii, imax, iresat(natmax), 
     .        j, jj, jmax, k, lmot, lnomeig, lnompdb, natom, 
     .        nddl, nmots, nres, numvec(natmax), numsel, nunit, nvec, 
     .        uneig, unmod, unout, unpdb
      double precision freq(3*natmax), massat(natmax), 
     .        matvec(3*natmax,nvecmx), norme, normtot, 
     .        xat(natmax), xmod, yat(natmax), ymod, zat(natmax), zmod
      logical qerror, qexist, qok, qinter, qlist, qmasse
      character atonam(nresmx)*4, cformat*10, cstatus*10, 
     .        mots(nmotsmax)*132, namfil*64, 
     .        nomeig*64, nompdb*64, program*8, progrer*11, progrwn*11, 
     .        resnam(natmax)*4, ssusel*1, version*40
 
      version=' Version 1.20, Bordeaux.'
      program=' Rmsmod>'
      progrwn='%Rmsmod-Wn>'
      progrer='%Rmsmod-Er>'
 
      write(6,'(2A)') program,version
 
      call getnam('Eigenvector filename ?',nomeig,lnomeig,qok)
      if (.not.qok) stop
 
      numsel=-1
      call getnum('Eigenvector Number ?',numsel,1,nvecmx,qok)
 
      nunit=10
      uneig=nunit
      nunit=nunit+1
      cformat="FORMATTED"
      cstatus="old"
      call openam(nomeig,cformat,cstatus,uneig,.true.,
     .            qinter,qexist)
      if (qinter.or..not.qexist) stop
 
      call getnam('Corresponding pdb file ?',
     .     nompdb,lnompdb,qok)

      if (.not.qok) then
          write(6,'(2A)') program,
     .  ' Atom names and masses will be missing.'
          qlist=.true.
          goto 100
      else
          qlist=.false.
      endif
 
      call string_split(nompdb,lnompdb,':',
     .                  mots,nmotsmax,nmots)
      call stringcl(mots(1),lmot)
 
      if (nmots.gt.1) then
          call stringcl(mots(2),lmot)
          ssusel=mots(nmots)
          write(6,'(3A)') program,' Subunit to be selected: ',ssusel
          if (nmots.gt.2) then
              write(6,'(4A)') progrer,
     .      ' The end of pdb name, ',
     .        nompdb(1:lnompdb),', has not been understood.'
          endif
      else
          ssusel=' '
      endif
      nompdb=mots(1)
 
      unpdb=nunit
      nunit=nunit+1
      call openam(nompdb,cformat,cstatus,unpdb,.true.,
     .            qinter,qexist)
      if (qinter.or..not.qexist) stop
 
      call getrep(
     .    'Are the masses given in the pdb files ? (y/n)',
     .     qmasse,qok)
      if (.not.qok) qmasse=.false.
 
      if (qmasse) then
          write(6,'(/2A)') program,
     .  ' Masses will be picked in the pdb files.'
      else
          write(6,'(/2A)') program,
     .  ' All masses will all be assumed to be of 1.'
      endif

c     Lecture:
c     -------
 100  continue
      call rdmodfacs(uneig,3*natmax,nvecmx,numvec,freq,
     .               matvec,nddl,nvec,numsel)
 
      write(6,'(/A,I5,A,I6,A)') program,
     .      nvec,' vectors, ',nddl,' coordinates in file.'
 
      if (numvec(nvec).ne.numsel) then
          write(6,'(2A,I6,A)') progrer,
     .  ' Vector ',numsel,' not found in vector file.'
          stop
      endif
      if (qlist) goto 200 

      call rdatompdb(unpdb,ssusel,xat,yat,zat,massat,
     .     atonam,iresat,resnam,natmax,natom,
     .     fatres,nresmx,nres,qerror)
 
      if (nddl.eq.3*natom) then
          write(6,'(/2A)') program,
     .  ' Cartesian (eigen)vectors will be studied.'
      else if (nddl.gt.0) then
          write(6,'(/2A)') progrer,
     .  ' Vector and reference pdb file are not consistent.'
          stop
      else if (nddl.le.0.or.nvec.le.0) then
          write(6,'(/2A)') progrer,
     .  ' Nothing can be done.'
          stop
      endif
 
c     Sortie:
c     ------
 200  continue
      namfil='rmsmod.res'
      unout=nunit
      nunit=nunit+1
      cformat="FORMATTED"
      cstatus="ove"
      call openam(namfil,cformat,cstatus,unout,.true.,
     .            qinter,qexist)
 
      write(6,'(2A)') program,
     .' Displacement=f(atom number) to be written in this file.'
 
      namfil='eigvec.res'
      unmod=nunit
      nunit=nunit+1
      cstatus="ove"
      call openam(namfil,cformat,cstatus,unmod,.true.,
     .            qinter,qexist)
 
      write(6,'(2A)') program,
     .' Vector coordinates=f(atom number) to be written in this file.'
 
      normtot=0.d0
      do i=1,natom
         ii=3*i-2
         norme=matvec(ii,numsel)**2.d0+
     .         matvec(ii+1,numsel)**2.d0+
     .         matvec(ii+2,numsel)**2.d0
         normtot=normtot+norme
         if (qmasse) norme=norme/massat(i)
         norme=dsqrt(norme)
         if (qlist) then
             write(unout,'(I6,F8.4)') i,norme
         else
             write(unout,'(I6,2X,A,I6,2X,A,F8.4)') 
     .       i,resnam(i),iresat(i),atonam(i),norme
         endif 
      enddo
      
      do i=1,nddl,3
         iat=(i+2)/3
         xmod=matvec(i,numsel)
         ymod=matvec(i+1,numsel)
         zmod=matvec(i+2,numsel)
         if (qmasse) then
             xmod=xmod/dsqrt(massat(iat))
             ymod=ymod/dsqrt(massat(iat))
             zmod=zmod/dsqrt(massat(iat))
         endif
         if (qlist) then
             write(unmod,'(I6,3F8.4)') iat,xmod,ymod,zmod
         else
             write(unmod,'(I6,2X,A,I6,2X,A,3F8.4)') 
     .       iat,resnam(iat),iresat(iat),atonam(iat),xmod,ymod,zmod
         endif
      enddo
 
      write(6,'(2A,I5,A,F8.4)') program,
     .    ' Norm of vector ',numsel,' = ',normtot 
 
      write(6,'(/2A)') program,' Normal end.'
 
      stop
      end
c
c     Questions/reponses.
c     Serie de routines utilitaires:
c     getnum
c     getnam
c     Version 1.3, Bordeaux.
c
      subroutine getnum(message,numlu,nummin,nummax,qok)
c
c     NUMLU obtenu en reponse au MESSAGE.
c     NUMLU doit etre inferieur a nummax et superieur a nummin.
c
c     NTRYMX essais en cas de probleme.
c     qok=.false. => Probleme a la lecture.
c
c     YHS-oct-1996: version 1.0
c     YHS-nov-2000: version 3.0
c
      implicit none
cI/O:
      integer numlu, nummax, nummin
      logical qok
      character*(*) message
cLocal:
      integer ntry, ntrymx, iread
cBegin:
      ntrymx=5
c
      qok=.false.
      ntry=0
c
 100  continue
      ntry=ntry+1
      if (ntry.ge.ntrymx) return
c
      write(6,'(A,A)') ' Getnum> ',message
      read(5,*,end=200,err=100) iread
      numlu=iread
c
      write(6,*) 'Getnum> ',numlu
      if (numlu.gt.nummax) then
          write(6,'(A,I6,A)') 
     .  '%Getnum-Err: number larger than ',nummax,
     .  ' This is not allowed. Sorry.'
          numlu=nummax
          return
      else if (numlu.lt.nummin) then
          write(6,'(A,I6,A)') 
     .  '%Getnum-Err: number smaller than ',nummin,
     .  ' This is not allowed. Sorry.'
          numlu=nummin
          return
      endif
c
      qok=.true.
      return
 200  continue
      return
      end 
c---------------------------------------------------
      subroutine getnam(message,nomlu,lnomlu,qok)
c
c     NOMLU obtenu en reponse au MESSAGE.
c     NTRYMX essais en cas de probleme.
c     YHS-oct-96
c
      implicit none
cI/O:
      integer lnomlu
      logical qok
      character*(*) message, nomlu
cLocal:
      integer ntry, ntrymx
cBegin:
      ntrymx=5
c
      qok=.false.
      ntry=0
c
 100  continue
      ntry=ntry+1
      if (ntry.ge.ntrymx) return
c
      write(6,'(A,A)') ' Getnam> ',message
      read(5,'(A)',end=200,err=100) nomlu
c
      call stringcl(nomlu,lnomlu)
      write(6,'(A,A)') ' Getnam> ',nomlu(1:lnomlu)
c
      qok=.true.
      return
 200  continue
      return
      end 
c
      subroutine rdmodfacs(uneig,nddlmax,nvecmx,numvec,freq,
     .           matvec,nddl,nvec,numsel)
c
c     Lecture de modes CERFACS.
c     Devra remplacer rdcerfacs.
c     Difference: comptage de l'ordre de la matrice.
c    (et pas des atomes)
c
c     Premieres versions (rdcerfacs):
c     YHS-Nov-1996.
c     Dernieres modifications:
c     YHS-Jan-2001.
cI/O:
      integer numvec(*), numsel,
     .        nvecmx, nddlmax, nvec, nddl, uneig
      double precision freq(*), matvec(nddlmax,*)
cLocal:
      integer nmotsmax
      parameter(nmotsmax=100)
      integer nerr, ivec, indnm_cfacs, nmots,
     .        i, ii, j, jj, k, kk
      double precision wtofreq
      logical qfound, qold, qfirst
      character*1 carnum
      character*132 lign132, mots(nmotsmax)
cDefaut:
c     Facteur de conversion (2*pi*f)**2 -> f (cm-1):
      wtofreq=108.586698
c
      nerr=0
      qfirst=.true.
      qold=.false.
      qfound=.false.
 100  continue
      read (uneig,'(A)',end=300,err=110) lign132
      goto 120
 110  continue
      nerr=nerr+1
 120  continue
c
      qfound=qfound.or.
     .      (index(lign132,' value ').gt.0.and.
     .       index(lign132,' vector ').gt.0.and.
     .       index(lign132,' residual ').le.0)
      qold=qold.or.
     .      (index(lign132,' VALUE ').gt.0.and.
     .       index(lign132,' VECTOR ').gt.0)
c
      if (.not.qfound.and..not.qold) goto 100
c________________________________________
c
c     Lecture des frequences des modes :
c________________________________________
c
      if (qfirst) then
          if (qold) then
          write(6,'(/A)') 
     .  ' Rdmodfacs> Old Blzpack file format detected.'
          else
          write(6,'(/A)') 
     .  ' Rdmodfacs> Blzpack file format detected.'
          endif
          qfirst=.false.
      endif
c
      ivec=0
      nvec=0
 250  continue
      ivec=ivec+1
      if (ivec.gt.nvecmx) then
          write(6,'(/A,I5,A)') 
     .  '%Rdmodfacs-Err> More than ',nvecmx,' vectors in file.'
          return
      endif
c
      read(lign132,'(7X,I5,12X,G12.4)',end=240,err=240)
     .     numvec(ivec), freq(ivec)
      freq(ivec)=wtofreq*dsqrt(abs(freq(ivec)))
c
      goto 255
 240  continue
      write(6,'(/3A)')
     .    '%Rdmodfacs-W> Pb with ligne: ',lign132(1:36),'...'
 255  continue
c
      nvec=ivec
      write(6,'(/A,I6)')
     .    ' Rdmodfacs> Numero du vecteur CERFACS en lecture:',
     .      numvec(ivec)
      write(6,'(A,1PG12.4)')
     .    ' Rdmodfacs> Frequence du vecteur en lecture:',
     .      freq(ivec)
c
      if (numvec(ivec).le.0)
     .    write(6,'(/A/A)')
     .  '%Rdmodfacs-W> Vector number was expected in:',
     .    lign132
c
      read(uneig,'(A)',end=230,err=230) lign132
 230  continue
      read(lign132,'(1X,A1)',end=232,err=232) carnum
 232  continue
      if ((qfound.and.carnum.ne.'=').or.
     .    (qold.and.carnum.ne.'-')) then
          write(6,'(2A/A)')
     .       ' %Rdmodfacs-Warning> Unexpected character ',
     .       ' in second column of line:',
     .    lign132
      endif
c____________________________________________________
c
c     2) Lecture des coordonnees des modes CERFACS :
c        Format libre.
c____________________________________________________
c
      k=0
 257  continue
      if (k.ge.nddlmax) then
          write(6,'(/A,I6,A,I5)') 
     .  '%Rdmodfacs-Err> More than ',nddlmax,
     .  ' coordinates for vector ',ivec
          return
      endif
c
      read(uneig,'(A)',end=300,err=270) lign132
c
c     Nombre de coordonnees par ligne:
      call string_split(lign132,132,' ',
     .                  mots,nmotsmax,nmots)
c
      if (lign132.eq.' ') then
          read(uneig,'(A)',end=300,err=260) lign132
      else if (.not.qold.or.index(lign132,' VALUE ').le.0) then
          read(lign132,*,end=258)
     .   (matvec(k+ii,ivec),ii=1,nmots)
          k=k+nmots
          goto 257
 258      continue
      endif
      nddl=k
c
 260  continue
      indnm_cfacs=index(lign132,'       VALUE')
      if (indnm_cfacs.le.0)
     .    indnm_cfacs=index(lign132,'       value')
      if (indnm_cfacs.gt.0) then
          if (numvec(ivec).eq.numsel) goto 300
          goto 250
      else
          write(6,'(A,A/A/A)')
     .  ' Rdmodfacs: Lecture des modes CERFACS terminee.',
     .  ' Item VALUE non trouve dans la ligne:',lign132
          goto 300
      endif
c
 270  continue
      write(6,'(A,I6,A)')
     .   ' %Rdmodfacs-Error: durant la lecture de la coordonnee ',
     .      i,' du mode.'
      stop
c
 220  continue
c*****Ligne suivante de la lecture du fichier des modes en cours :
c
      goto 100
c
c     Fin de la lecture du fichier des modes :
c
 300  continue
      return
      end
c
c     Lecture de noms de fichier + Ouverture.
c     Serie de routines utilitaires:
c     openam
c     stringcl
c     string_split
c     Version 1.11, Bordeaux.
c
      SUBROUTINE openam(namfil,cformat,cstatus,unit,qverbos,
     .                  qinterr,qexist)
c
c     Ouverture d'un fichier de nom NAMFIL, sur l'unite UNIT.
c
c     input:
c        namfil: nom du fichier a ouvrir. 
c        "stop", "end", "fin", "quit" : arretent le programme.
c        cstatus: mots-cles fortran... ou "OVE" pour overwrite.
c     output: 
c        qexist: flag / existence du fichier 
c        qinterr: Pas de nom pour le fichier cherche.
c
c     YHS-oct-1993: Premiere version.
c     YHS-jan-2000: Derniere modification.
c I/O:
      logical qinterr, qverbos, qexist
      integer unit
      character*10 cformat, cstatus
      character*64 namfil
c Local
      character*132 ordrunix
c begin:
      if (cstatus.eq.'old') cstatus='OLD'
      if (cstatus.eq.'new') cstatus='NEW'
      if (cstatus.eq.'ove') cstatus='OVE'
      if (cstatus.eq.'unknown') cstatus='UNKNOWN'
c
      qinterr=.false.
      qexist=.false.
c
      if (namfil.eq.' ') then 
          qinterr=.true.
          write(6,'(A)') '%Openam-Err> No filename.'
          return
      endif
c
      if (namfil.eq.'stop'.or.namfil.eq.'end'                         
     &    .or.namfil.eq.'fin'.or.namfil.eq.'quit') then 
         write(*,*) 'Openam> Program is stopping on user request.'
         stop                                                                   
      endif 
c
c     Checks if filename is consistent with the opening:
c
      inquire(file=namfil,exist=qexist)
      if (.not.qexist.and.cstatus.eq.'OLD') then
          qinterr=.true.
          write(6,'(A)') '%Openam-Err> File not found.'
          return
      endif
c
      if (qexist.and.cstatus.eq.'NEW') then
         write(*,'(/A)') 
     .      '%Openam-Err> This file exists:',namfil
         stop
      else if (qexist.and.cstatus.eq.'OVE') then
         ordrunix='rm '//namfil
         call system(ordrunix)
      endif
      if (cstatus.eq.'OVE') cstatus='NEW'
c                                                                   
      if (qverbos) then
         write(*,'(/A,I6,A)')
     .           ' Openam> file on opening on unit ',unit,':'
         write(*,*) namfil
      endif
      open(file=namfil,form=cformat,
     .     status=cstatus,unit=unit)                
c        
      return                                                                       
      end
c
      subroutine string_split(chaine,taille,delimiteur,
     .                        souschaine,nbremax,nbre)
c
c     "Chaine" est coupee en "nbre" "souschaine" de part et d'autre du
c     "delimiteur"
c      YHS-Sep-93, Uppsala
c I/O:
      integer taille, nbremax, nbre
      character*(*) chaine, souschaine(*), delimiteur
c Local:
      integer icar, iprev
c
      nbre=1
      iprev=1
      souschaine(1)=chaine
      do icar=1,taille
         if (chaine(icar:icar).eq.delimiteur) then
            if (icar-1.ge.iprev) then
               souschaine(nbre)=chaine(iprev:icar-1)
               nbre=nbre+1
               if (nbre.le.nbremax) then
                  if (icar+1.le.taille.and.
     .               chaine(icar+1:taille).ne.' ') then
                     souschaine(nbre)=chaine(icar+1:taille) 
                  else
                     nbre=nbre-1
                     return
                  endif
               else
                  write(6,'(A,I6,A/A)') 
     .               ' %String_split-Err: more than ',nbremax,
     .               ' substrings in : ',chaine
                  return
               endif
            endif
            iprev=icar+1
         endif
      enddo
c
      return
      end
c
      subroutine stringcl(chaine,nonblancs)
c
c     Les caracteres "blancs" de la CHAINE sont retires (a gauche et au milieu).
c     L'entier NONBLANCS donne la position du dernier caractere.
c
c     YHS-Jan-95, Toulouse.
c     YHS-Oct-00, Bordeaux.
c I/O:
      integer nonblancs
      character*(*) chaine
c Local:
      integer icar, ncar, taille
c Begin:
      nonblancs=0
      taille=len(chaine)
      if (taille.le.0) return
c
      if (index(chaine(1:taille),' ').le.0) then
          nonblancs=taille
          return
      endif
c
c*****Nettoyage des blancs a gauche.
c     Premier non-blanc:
c
      do icar=1,taille
         if (chaine(icar:icar).ne.' ') goto 150
      enddo
      icar=taille
 150  continue
      chaine=chaine(icar:taille)
c
c*****Nettoyage des blancs au milieu.
c
          icar=1
          ncar=1
 170      continue
          icar=icar+1
          ncar=ncar+1
          if (chaine(icar:icar).eq.' ') then
              chaine=chaine(1:icar-1)//chaine(icar+1:taille) 
              icar=icar-1
          endif
          if (ncar.lt.taille-1) goto 170
c
      nonblancs=index(chaine,' ')-1
c
      return
      end

      subroutine rdatompdb(unpdb,ssusel,xat,yat,zat,binfo,
     .           atonam,iresat,resnam,natmax,natom,
     .           fatres,nresmx,nres,qerror)
c
c     Lecture ligne a ligne d'un fichier pdb.
c     Uniquement les lignes commencant par 'ATOM'.
c     Uniquement ceux de la sous-unite selectionnee.
c
c     fatres(i): numero du premier atome du residu i.
c     YHS-novembre-1996.
c
      implicit none
cI/O:
      integer unpdb, natmax, iresat(*), natom, 
     .        nresmx, nres, fatres(*)
      double precision xat(*), yat(*), zat(*), binfo(*)
      logical qerror
      character*4 atonam(*), resnam(*)
      character*1 ssusel
cLocal:
      integer nerr, iatom, irs, irsprev, lmot, ntit
      double precision x, y, z, bfact
      character*1  ssu
      character*4  ren
      character*5  atncur
      character*80 lign80
cBegin:
      write(6,'(/A)') ' Rdatompdb> Reading pdb file.'
c
      qerror=.false.
      nerr=0
c
      irsprev=-1
      nres=0
      iatom=0
      ntit=0
 105  continue   
      read(unpdb,'(A)',end=200,err=110) lign80 
c 
      goto 120                                
 110  continue
      nerr=nerr+1                            
c
 120  continue                              
      if (lign80(1:4).eq.'ATOM') then
      read(lign80,'(12X,A4,1X,A4,A1,I4,4X,3F8.3,6X,F6.2)') 
     .            atncur, ren, ssu, irs, x, y, z, 
     .            bfact
      if (iatom.lt.natmax) then
          if (ssu.eq.ssusel.or.ssusel.eq.' ') then
          iatom=iatom+1
          xat(iatom)=x
          yat(iatom)=y
          zat(iatom)=z
          binfo(iatom)=bfact
c
          call stringcl(atncur,lmot)
          atonam(iatom)=atncur
          call stringcl(ren,lmot)
          resnam(iatom)=ren
          iresat(iatom)=irs
c
          if (irs.ne.irsprev) then
              nres=nres+1
              if (nres.gt.nresmx) then
                  write(6,'(A/A,I6)') 
     .          '%Rdatompdb-Err> Too many residues in this file.',
     .          ' Maximum allowed is = ',nresmx
                  stop
              endif
              irsprev=irs
              fatres(nres)=iatom
          endif
          endif
      else
          write(6,'(A/A,I6)') 
     .      '%Rdatompdb-Err> Too many atoms in this file.',
     .      ' Maximum allowed is = ',natmax
          stop
      endif
      else if (lign80(1:6).eq.'REMARK') then
          ntit=ntit+1
          if (ntit.le.10) then
              write(6,'(A)') lign80
          else if (ntit.eq.11) then
              write(6,'(A)') ' .... '
          endif
      endif
c
c     2) Ligne suivante du fichier pdb :
c
      goto 105
c
c     3) Fin de la lecture du fichier pdb :
c
 200  continue 
      write(6,*) 'Rdatompdb> End of file reached.'
      write(6,*) 'Rdatompdb> Number of I/O errors: ',
     .            nerr
c
      natom=iatom
      fatres(nres+1)=natom+1
      irs=0
      if (natom.gt.0) irs=iresat(natom)
c
      write(6,'(/(A,I6))') 
     .' Rdatompdb> Number of residues found = ',nres,
     .'            First residue number     = ',iresat(1),
     .'            Last  residue number     = ',irs,
     .'            Number of atoms found    = ',natom
      write(6,'(A,F8.1)') 
     .'            Mean number per residue  = ',float(natom)/float(nres)
c
      if (natom.eq.0) then
          write(6,'(A)')
     .  '%Rdatompdb-Err> No atom found in file.'
          qerror=.true.
      endif
      if (nres.eq.0) then
          write(6,'(A)')
     .  '%Rdatompdb-Err> No residue found in file.'
          qerror=.true.
      endif
c
      return
      end
c---------------------------------------------------
      subroutine getrep(message,qinfo,qok)
c
c     qinfo obtenu en reponse au MESSAGE.
c     NTRYMX essais en cas de probleme.
c     YHS-jan-00
c     YHS-oct-00
c
      implicit none
cI/O:
      logical qok, qinfo
      character*(*) message
cLocal:
      integer ntry, ntrymx
      character*1 cread
cBegin:
      ntrymx=2
c
      qinfo=.false.
      qok=.false.
      ntry=0
c
 100  continue
      ntry=ntry+1
      if (ntry.ge.ntrymx) then
          goto 200
          return
      endif
c
      write(6,'(A,A)') ' Getrep> ',message
      read(5,'(A)',end=200,err=100) cread
c
      if (cread.eq.'T'.or.cread.eq.'t'.or.
     .    cread.eq.'Y'.or.cread.eq.'y'.or.
     .    cread.eq.'O'.or.cread.eq.'o') then
          qinfo=.true.
      else
      if (cread.ne.'F'.and.cread.ne.'f'.and.
     .    cread.ne.'N'.and.cread.ne.'n')
     .    write(6,'(3A)') '%Getrep-W> Unexpected answer:',cread,
     . '. Assumed answer is: NO.'
      endif
c
      write(6,*) 'Getrep> ',qinfo
c
      qok=.true.
      return
 200  continue
      write(6,'(A)') '%Getrep-W> No answer.'//
     .    ' Assumed answer is: NO.'
      return
      end 
