      program Trajmod
c    
c     Reads modes HONDO, GAUSSIAN, "Cerfax".    
c     Reads pdb files, if necessary.
c     Calcul de la trajectoire correspondante
c
c     Ameliorations a envisager:
c     -Cartes "de Go" epurees (1pt/4,9,16,etc) si (bien) plus de 200 residus;
c      Numerotation des residus en suivant le fichier pdb.
c     -Lecture avortee si frequences par ordre croissant et fmax atteint...
c     -Noms des fichiers: la frequence (ou dans le titre)
C     -Gaussian, Hondo: dans fichier pdb, "CONECT I5,I5" (no liaison H-H)
c     -Language de commandes 
c
c     Premiere version: YHS-septembre-93, Uppsala.
      
      implicit none
      
      integer natmax, nvecmx, nresmx
      parameter(natmax=10000,nvecmx=106,nresmx=1000)
 
      logical qrange(80), qunmass, qexist, qoutput, qowat, qaddwat,
     .        qinterr, qscan, qhondo, qstart, qlast, qtest
      integer i, iatom, ierr, ii, imod, indblc, indcr_gauss, 
     .        indnm_cfacs, indnm_gauss, indnm_hondo, indok_gauss, 
     .        indunit, irange, ires(natmax), irs, irsmax, itraj, 
     .        itype, ivec, I0, j, jatom, jj, jmin, jmod, k, kk, 
     .        natom, natuse, ncurr, nerr, nlettres, nnuls, nmod, nmots, 
     .        nper, npoints, nrange, nrenum, nres, nsel, ntit, ntraj,
     .        numvec(nvecmx), nvec, nwat, selatom(natmax), 
     .        selvec(nvecmx), taille, unmod, unout, unout2, unpdb  
      double precision twopi, rcste, distca(nresmx,nresmx),
     .       freq(nvecmx), masse(natmax),
     .       qmax(nvecmx), permod(nvecmx), rnorm, dmin, dmax,
     .       matvec(3*natmax,nvecmx), vect(12), kmin,
     .       x, y, z, bfact, dist2, dist, norm, qnorm,
     .       xat(natmax), yat(natmax), zat(natmax),
     .       frange(80), lrange(80), cosvec(20,20),
     .       tpsec, tper, dfmin, drange, fmin,
     .       dtpsec, timeps, qmod, sumdr, factmoy,
     .       permin, emax, rms, rmsd, moy, wtofreq,
     .       xtr(natmax), ytr(natmax), ztr(natmax)
      character action*64, atn*4, atonam(natmax)*4, 
     .       bionm1*19, bionm2*19, carnum*1, cformat*10, cstatus*10, 
     .       debfin(80)*80, inpmod*64, inppdb*64, lign132*132,
     .       lign80*80, mot(80)*80, program*12, outfil*64, outfil2*64, 
     .       outfil3*64, range(80)*80, ren*4, resnam(natmax)*4, 
     .       title(100)*80
 
      twopi=6.283185
      rcste=8.31362
 
c     Facteur de conversion (2*pi*f)**2 -> f (cm-1):
      wtofreq=108.586698
 
      program=' Traj_modes>'
      write(6,'(2A)') program,' version 3.13 (Avril 2002).'
 
c     Kind of desired cartesian trajectory :
c     Removing mass-weighting ?
c
      qunmass=.true. 
      qaddwat=.false.
      qtest=.false.
c
c*****LECTURE DES INSTRUCTIONS:
c     Ouverture des fichiers d'input...
c
      i=0
      unmod=11
 20   continue                                                                  
      i=i+1
      if (i.gt.100) stop
c
      write(6,'(A)') ' Name of the normal modes file to be read ?'
      read(*,'(A)',end=20,err=20) inpmod
c
      cformat="formatted"
      cstatus="old"
      call openam(inpmod,cformat,cstatus,unmod,.false.,qinterr,qexist)
      if (qinterr) goto 20
      ntit=1
      title(ntit)='*Mode file:'//inpmod
c
      i=0
      unpdb=10
 10   continue                                                                  
      i=i+1
      if (i.gt.100) stop
      write(6,'(A)') 
     .   '  Name of the pdb file, for the studied structure:'
      if (qunmass)
     .write(6,'(A)') 
     .   '( with atomic masses in the BFACT column )'
      read(*,'(A)',end=10,err=10) inppdb                                        
c
      i=0
 25   continue                                                                  
      i=i+1
      if (i.gt.100) stop
c
      write(6,'(A)') '  Type of calculation to be performed ? ',
     .           '( Trajectory-ies / One-trajectory / Projection )'
c
      read(*,'(A)',end=25,err=25) lign80
      call stringcl(lign80,taille)
      if (lign80(1:1).eq.'T'.or.lign80(1:1).eq.'t') then 
         action='TRAJECTOIRE'
      else if (lign80(1:1).eq.'O'.or.lign80(1:1).eq.'o') then
         action='UNE-TRAJECTOIRE'
      else if (lign80(1:1).eq.'P'.or.lign80(1:1).eq.'p') then
         action='PROJECTION'
      else  
         write(6,*) 
     .        '%Traj_modes-W: Type not understood. TRAJECTORY assumed.'
         action='TRAJECTOIRE'
      endif
      ntit=ntit+1
      title(ntit)='*Action:'//action
c
      if (action.eq.'TRAJECTOIRE'.or.action.eq.'UNE-TRAJECTOIRE') then
      i=0
 50   continue                                                                  
      i=i+1
      if (i.gt.100) stop
      write(6,'(A)')
     .    '  Prefix-filename for the trajector(ies) to be computed ?',
     .    '( Filename(s)="Prefix"+"mode number"+".dcd" )'
      read(*,'(A)',end=50,err=50) outfil                                        
      endif
c
      i=0
 405  continue                                                                  
      i=i+1
      if (i.gt.100) stop
c
      write(6,'(2A)')'  Frequency range, or approximate frequency, ',
     .               'of the chosen modes ? '
      write(6,'(A)') '( for instance : 100-250, 300, 1000-1200 ) '
c
      read(*,'(A)',end=405,err=405) lign80
c
      if (index(lign80,'stop').gt.0) stop
      call string_split(lign80,80,',',range,80,nrange)
      if (nrange.eq.0) goto 405
c
      if (action.eq.'PROJECTION') goto 650
      i=0
 410  continue                                                                  
      i=i+1
      if (i.gt.100) stop
c
      write(6,'(A/A)')
     .'  Number of periods of the trajectory to be computed ?',
     .'( as far as the lowest-(absolute)-frequency mode is concerned )'
c
      read(*,*,end=410,err=410) tper
c
      i=0
 610  continue                                                                  
      i=i+1
      if (i.gt.100) stop
c
      write(6,'(A)')
     .    '  Energy on each mode ? (kcal/mole) '
c
      read(*,*,end=610,err=610) emax
c
      i=0
 600  continue                                                                  
      i=i+1
      if (i.gt.100) stop
c
      write(6,'(A)')
     .    '  Number of points in the trajectory to be computed ?'
c
      read(*,*,end=600,err=600) npoints
c
c*****Lecture des fichiers :
 650  continue
      nerr=0
c     
c*****Lecture ligne a ligne du fichier des modes :
c     1) Initialisations :
c
      do i=1,nvecmx
         freq(i)=0.d0
         do j=1,3*natmax
            matvec(j,i)=0.d0
         enddo
      enddo
c
      natom=0
      qscan=.false.
      qstart=.false.
      qhondo=.true.
c
c     2) Lecture:
 205  continue                          
      read(unmod,'(A)',end=300,err=210) lign132   
c
      goto 215
 210  continue
      nerr=nerr+1                                                                  
 215  continue
c
c*****GAUSSIAN (modes+coordonnees) :
c  
      if (.not.qscan) then
c     Recherche de "la" (d'une) zone caracteristique d'un fichier GAUSSIAN :
c     qscan=true <=> fichier d'un autre type deja identifie.
c
        indok_gauss=index(lign132,
     .             '                  Standard orientation:')
        if (indok_gauss.gt.0.) then
           qstart=.true.
           goto 205
        endif
c
c       1) Recherche de la zone "lecture des coordonnees" d'un fichier GAUSSIAN :
c
        indcr_gauss=index(lign132,
     .             'Center     Atomic              Coordinates')
        if (natom.le.0.and.indcr_gauss.gt.0.and.qstart) then
           qhondo=.false.
           write(6,'(/A)') 
     .         ' Trajmod> Reading coordinates from Gaussian output.'
           read(unmod,'(/)')
 206       continue
           read(unmod,'(A)',end=300) lign132
           if (lign132(2:6).eq.'-----') goto 207
           read(lign132,'(I5,6X,I5,7X,3F12.6)',err=207) 
     .                  iatom,itype,x,y,z
           natom=iatom
           goto 208
 207       continue
           write(6,'(/A,I6,A/)') ' Trajmod> ',natom,' atoms found.'
           if (natom.le.0) then
              goto 300
           endif
c
c          Sortie du fichier pdb:
c
           cformat="formatted"
           cstatus="new"
           call openam(inppdb,cformat,cstatus,unpdb,
     .                .true.,qinterr,qexist)
           if (qinterr) then
               write(6,'(A)') 
     .        '%Trajmod-W: pdb file not created.'
               goto 205 
           endif
c
           irs=1
           write(unpdb,'(A4,I7,1X,A4,A4,2X,I4,4X,3F8.3,6X,F6.2)') 
     .         ('ATOM',i, atonam(i), 'GAUS', irs, 
     .          xat(i), yat(i), zat(i), 
     .          masse(i),i=1,natom)
c
c          Poursuite de la lecture du fichier:
           goto 205
 208       continue
c
           if (iatom.le.0) then
             write(6,'(A/A)') 
     .        ' %Trajmod-Err> while reading atomic coordinates in :',
     .          lign132
             goto 300
           endif
c
           if (iatom.le.natmax) then
              xat(iatom)=x
              yat(iatom)=y
              zat(iatom)=z
c
c             Attribution des masses :
              if (qunmass) then
              if (itype.eq.1) then
                 masse(iatom)=1.d0
                 atonam(iatom)='H'
              else if (itype.eq.6) then
                 masse(iatom)=12.d0
                 atonam(iatom)='C'
              else if (itype.eq.7) then
                 masse(iatom)=14.d0
                 atonam(iatom)='N'
              else if (itype.eq.8) then
                 masse(iatom)=16.d0
                 atonam(iatom)='O'
              else
                 write(6,'(A,I6,A)') 
     .              ' %Trajmod-Err> Sorry. mass of atom type ',itype,
     .              ' is unknown. You have to add it to the code.'
                 goto 300
              endif
              endif
              goto 206
          else
              write(6,'(A/A,I6,A)') 
     .        '%Trajmod-Err> atomes trop nombreux dans ce fichier.',
     .        ' Nombre maximum = ',natmax,' atteint.'
              goto 300
          endif
        endif
c
c       2) Recherche de la zone "modes normaux" d'un fichier GAUSSIAN :
c
        indnm_gauss=index(lign132,'Harmonic frequencies ')
        if (indnm_gauss.gt.0) then
           if (natom.le.0) then
              write(6,'(A,I6,A)') 
     .     ' %Trajmod-Err> No atomic coordinates found prior to modes.'
              goto 300
           endif
           write(6,*) 
     .          'Trajmod> Reading normal modes from Gaussian output.'
           write(6,*) 
     .          '         Number and Frequency of modes being read :'
           qlast=.false.
           read(unmod,'(/)')
 212       continue
           read(unmod,'(18X,5I10)',err=214) 
     .         (numvec(i),i=1,5)
 214       continue
           ivec=5
           nvec=numvec(5)
           if (nvec.le.0) then
              do i=1,4
                 if (numvec(6-i).le.0) then
                    ivec=5-i
                    nvec=numvec(5-i)
                    numvec(5)=nvec
                 endif
              enddo
              qlast=.true.
           endif
           write(6,'(5I10)') (numvec(i),i=1,ivec)
c
           read(unmod,'(/24X,5F10.4)',err=300) 
     .         (freq(i),i=numvec(1),numvec(5))
           write(6,'(5F10.4)')
     .         (freq(i),i=numvec(1),numvec(5))
           read(unmod,'(/////)')
c
           do i=1,3*natom
              read(unmod,'(A)') lign132
              read(lign132,'(23X,5F10.5)') 
     .            (matvec(i,j),j=numvec(1),numvec(5))
           enddo
           if (qlast) goto 300
           goto 212
        endif
      endif
c
c*****Besoin de la lecture du fichier pdb...
c    (fichier "modes normaux" de type autre que "GAUSSIAN" detecte)
c     qstart=true <=> type de fichier identifie, coordonnes lues.
c
      indnm_hondo=index(lign132,'NORMAL MODES')
      indnm_cfacs=index(lign132,'       VALUE')
      if (indnm_cfacs.le.0) indnm_cfacs=index(lign132,'       value')
      if (indnm_cfacs.gt.0) then
          if (index(lign132,' residual ').le.0) then
              write(6,'(A)') ' Trajmod> CERFACS eigenvector file.'
          else
              indnm_cfacs=-1
          endif
      endif
c
      if (indnm_hondo.le.0.and.indnm_cfacs.le.0) goto 280
      if (qstart) goto 280
      qstart=.true.
c
      cformat="formatted"
      cstatus="old"
      call openam(inppdb,cformat,cstatus,unpdb,.true.,qinterr,qexist)
      if (qinterr) goto 10
c
c     1) Lecture ligne a ligne de la lecture du fichier pdb :
c                                                                             
      iatom=0
 105  continue                                                                  
      read(unpdb,'(A)',end=200,err=110) lign80                                  
c 
      goto 120                                                                              
 110  continue
      nerr=nerr+1                                                                  
c
 120  continue                                                                  
      if (lign80(1:4).eq.'ATOM') then
      read(lign80,'(4X,I7,1X,A4,1X,A4,1X,I4,4X,3F8.3,6X,F6.2)') 
     .            ii, atn, ren, irs, x, y, z, 
     .            bfact
      iatom=iatom+1
      if (iatom.le.natmax) then
          xat(iatom)=x
          yat(iatom)=y
          zat(iatom)=z
          call stringcl(atn,taille)
          atonam(iatom)=atn
c
c         Attribution des masses :
c
          if (qunmass) then
          masse(iatom)=bfact
          else
          masse(iatom)=0.d0
          endif
c
          call stringcl(ren,taille)
          resnam(iatom)=ren
          ires(iatom)=irs
      else
          write(6,'(A/A,I6,A)') 
     .      '%Trajmod-Err> atomes trop nombreux dans ce fichier.',
     .      ' Nombre maximum = ',natmax,' atteint.'
          goto 300
      endif
      endif
c
c     2) Ligne suivante du fichier pdb :
c
      goto 105
c
c     3) Fin de la lecture du fichier pdb :
c
 200  continue                                                                  
      write(6,*) 'Trajmod> Nombre de (petites) erreurs de lecture : ',
     .            nerr
      write(6,*) 'Trajmod> Fin de la lecture du fichier :',inppdb
c
      natom=iatom
      nres=irs
      write(6,*) 'Trajmod> Nombre des atomes du systeme :',natom
      if (qunmass) write(6,'(2A)') 
     .  ' Trajmod> Les masses ont ete prises ',
     .   'dans la colonne WMAIN/BFACT.'
c
 280  continue
c 
c*****HONDO :
c     1) Si le debut a ete detecte => Lecture du numero des vecteurs, etc.
c
      if (indnm_hondo.gt.0.and.qhondo) then
         write(6,*) lign132
         indunit=index(lign132,'CM**-1')
         if (indunit.le.0)   
     .       write(6,*) '%Trajmod-W> unite attendue: des cm-1...'
c
         qscan=.true.
         read(unmod,'(19X,12I9)',err=216) 
     .       (numvec(i),i=1,12)
 216     continue
c
         write(6,*) 'Trajmod> Numero des vecteurs HONDO en lecture:'
         write(6,'(12I6)') (numvec(i),i=1,12)
         read(unmod,'(//23X,12F9.2)',err=217) 
     .       (freq(i),i=1,12)
 217     continue
         write(6,*) 'Trajmod> Frequence des vecteurs en lecture:'
         write(6,'(12F6.0)') (freq(i),i=1,12)
c
         ivec=1
         nvec=12
         do i=ivec,nvec
            if (numvec(i).le.0) then
                nvec=i-1
                write(6,*) 'Trajmod> ',nvec,' vecteurs lus.'
                goto 205
            endif
         enddo
         goto 205
      endif
c
c     2) Numeros et frequences des vecteurs "HONDO" lus :
c     qscan=true <=> 1) realise...
c
      indnm_hondo=index(lign132,'NORM**(-1)')
      if (indnm_hondo.gt.0) then
         if (.not.qscan) then
            write(6,'(A/A)') 
     .      ' %Trajmod-Warning: item NORMAL MODES non detecte.',
     .      ' ...alors que la lecture de modes HONDO est abordee...'
            qscan=.true.
         endif
         ivec=ivec+12
         nvec=nvec+12
         read(unmod,'(//19X,12I9)',end=219,err=218) 
     .       (numvec(i),i=ivec,nvec)
 218     read(unmod,'(//23X,12F9.2)',end=219,err=219)
     .       (freq(i),i=ivec,nvec)
c
 219     continue
         if (numvec(ivec).le.0) then
            nvec=nvec-12
            write(6,*) 'Trajmod> ',nvec,' vecteurs lus.'
            goto 205
         endif
c
         write(6,*) 'Trajmod> Numero des vecteurs en lecture:'
         write(6,'(12I6)') (numvec(i),i=ivec,nvec)
         write(6,*) 'Trajmod> Frequence des vecteurs en lecture:'
         write(6,'(12F6.0)') (freq(i),i=ivec,nvec)
c
         do i=ivec,nvec
            if (numvec(i).le.0) then
              nvec=i-1
              goto 205
            endif
         enddo
         goto 205
      endif
c 
c     3) Lecture de modes HONDO :
c     (information preliminaire doit avoir ete lue <=> qscan=true)
c
      if (.not.qscan) goto 225
c
      if (natom.le.0) then
          write(6,'(A/A)') 
     .    ' %Trajmod-Error: pas de coordonnes lues precedemment.',
     .    ' ...alors que la lecture de modes HONDO commence...'
          stop
      endif
c
      if (lign132(20:23).eq.'  X ') then
          read(lign132,'(1X,I4,A4,13X,12F9.5)',end=220,err=210) 
     .         iatom,atn,(vect(i),i=1,12)
          if (iatom.gt.0.and.iatom.le.natom) then
            ii=3*iatom-2
            j=0
            do i=ivec,nvec
              j=j+1
              matvec(ii,i)=vect(j)
            enddo
          else
            write(6,*) 
     .      '%Trajmod-W. Numero atomique trop grand dans: ',lign132
          endif
          goto 220 
      endif
c 
      if (lign132(20:23).eq.'  Y ') then
          read(lign132,'(5X,A4,13X,12F9.5)',end=220,err=210) 
     .         atn,(vect(i),i=1,12)
          if (iatom.gt.0.and.iatom.le.natom) then
            ii=3*iatom-1
            j=0
            do i=ivec,nvec
              j=j+1
              matvec(ii,i)=vect(j)
            enddo
          else
            write(6,*) 
     .      '%Trajmod-W. Numero atomique trop grand pour: ',lign132
          endif
          goto 220   
      endif
c 
      if (lign132(20:23).eq.'  Z ') then
          read(lign132,'(5X,A4,13X,12F9.5)',end=220,err=210) 
     .         atn,(vect(i),i=1,12)
          if (iatom.gt.0.and.iatom.le.natom) then
            ii=3*iatom
            j=0
            do i=ivec,nvec
              j=j+1
              matvec(ii,i)=vect(j)
            enddo
          else
            write(6,*) 
     .      '%Trajmod-W. Numero atomique trop grand pour: ',lign132
          endif
          goto 220  
      endif
 225  continue
c
c*****Lecture de modes CERFACS :
c
      if (indnm_cfacs.gt.0) then
         if (natom.le.0) then
             write(6,'(A/A)') 
     .       ' %Trajmod-Error: pas de coordonnes lues precedemment.',
     .    ' ...alors que la lecture de modes CERFACS devrait commencer.'
             stop
         endif
c
c        1) Lecture des frequences des modes :
c          (quatrieme mot)
c
         ivec=0
         nvec=0
 250     continue
         ivec=ivec+1
         call string_split(lign132,132,' ',mot,80,nmots)
         call stringcl(mot(2),taille)
         read(mot(2)(1:taille),*,end=240,err=240) numvec(ivec)
         call stringcl(mot(4),taille)
         read(mot(4)(1:taille),*,end=240,err=240) freq(ivec)
         freq(ivec)=wtofreq*dsqrt(abs(freq(ivec)))
         goto 255
c
 240     continue
         write(6,'(/3A)') 
     .       '%Trajmod-W> Pb with ligne: ',lign132(1:36),'...'
 255     continue
c
         write(6,'(/A,I6)') 
     .       ' Trajmod> Numero du vecteur CERFACS en lecture:',
     .         numvec(ivec)
         write(6,'(A,1PG12.4)') 
     .       ' Trajmod> Frequence du vecteur en lecture:',
     .         freq(ivec)
c
         if (numvec(ivec).le.0) 
     .   write(6,'(/A/A)') 
     .       '%Trajmod-W> Vector number was expected in:',
     .         lign132
c
         read(unmod,'(A)',end=230,err=230) lign132
 230     continue
         read(lign132,'(1X,A1)',end=232,err=232) carnum
 232     continue
         if (carnum.ne.'='.and.carnum.ne.'-') then
             write(6,'(2A/A)') 
     .       ' %Trajmod-Warning> caracteres [=] ou [-] attendus',
     .       ' en deuxieme colonne de :',
     .       lign132
         endif
c
c        2) Lecture des coordonnees des modes CERFACS :
c           Format "Osni"...
c           Puis Format libre / Sortie de diagmat.
c
         do i=1,natom,2
            k=3*i-2
c           read(unmod,'(3(1PG12.4))',end=270,err=270) 
c           Pour Diagmat:
            if (i.eq.natom) then
                read(unmod,*,end=270,err=270) 
     .          matvec(k,ivec),matvec(k+1,ivec),matvec(k+2,ivec)
            else
                read(unmod,*,end=270,err=270) 
     .          matvec(k,ivec),matvec(k+1,ivec),matvec(k+2,ivec),
     .          matvec(k+3,ivec),matvec(k+4,ivec),matvec(k+5,ivec)
            endif
         enddo
         nvec=ivec
c
         read(unmod,'(A)',end=300,err=260) lign132
c        Ligne blanche entre deux vecteurs:
         if (lign132.eq.' ') 
     .       read(unmod,'(A)',end=300,err=260) lign132
c
 260     continue
         indnm_cfacs=index(lign132,'       VALUE')
         if (indnm_cfacs.le.0) 
     .       indnm_cfacs=index(lign132,'       value')
         if (indnm_cfacs.gt.0.and.ivec.lt.nvecmx) then
             goto 250
         else
             write(6,'(A,A/A/A)') 
     .      ' Trajmod: Lecture des modes CERFACS terminee.',
     .      ' Item VALUE non trouve dans la ligne:',lign132,
     .      ' ...ou nombre maximum de modes possibles atteint.'
             write(6,'(A,I6)') ' Trajmod> vector: ',ivec
             write(6,'(A,I6,I6/)') 
     .      ' Trajmod> Last elements read: ',k,k+5
             goto 300
         endif
c
 270     continue
         write(6,'(A,I6,A)') 
     .      ' %Trajmod-Error: durant la lecture de la coordonnee ',
     .        i,' du mode.'
         stop
      endif
c
 220  continue                                                                  
c
c*****Ligne suivante de la lecture du fichier des modes en cours :
c
      goto 205
c
c     Fin de la lecture du fichier des modes :
c
 300  continue                                                                  
      write(6,'(A/A)') 
     .     ' Trajmod> Fin de la lecture du fichier :',inpmod
c
c*****Test sur les modes lus :
c
      if (nvec.le.0) then
         write(6,*) '%Trajmod-Err> No mode read.'
         stop
      else
         write(6,'(/A,I6,A/)') ' Trajmod> ',nvec,' modes read.'
      endif
c
      do i=1,nvec
         norm=0.d0
         nnuls=0
         do j=1,3*natom
            norm=norm+matvec(j,i)**2.d0
            if (matvec(j,i).eq.0.d0) nnuls=nnuls+1
         enddo
         norm=dsqrt(norm)
         if (abs(norm-1.d0).gt.0.0001) then
            write(6,'(A,I6,A,F12.6,A)') 
     .    ' %Trajmod-W> Mode: ',i,' Norm= ',norm,' instead of one.'
            write(6,'(A,I6)')
     .    "  Nombre d'elements nuls du vecteur = ",nnuls
         endif
      enddo
c
c*****Mode selection according to input criteria :
c
      do i=1,nrange
         call string_split(range(i),80,'-',debfin,80,irange)
         if (irange.eq.1) then
            read(range(i),*,err=420) frange(i)
            lrange(i)=frange(i)
            goto 430
         endif
         if (irange.eq.2) then
            read(debfin(1),*,err=420) frange(i)
            read(debfin(2),*,err=420) lrange(i)
            if (frange(i).gt.lrange(i)) then
               drange=frange(i)
               frange(i)=lrange(i)
               lrange(i)=drange
            endif
            goto 430
         endif
 420     continue
         write(6,'(A/A)') 
     .      ' %Trajmod-Err> The following range was not understood :',
     .         range(i)
 430     continue
      enddo
c
c     1) Les modes sont-ils a l'interieur des intervalles ?
c
      do i=1,nrange
         qrange(i)=.false.
      enddo 
c
      do i=1,nvec
         selvec(i)=0
         do j=1,nrange
            if (freq(i).ge.frange(j).and.freq(i).le.lrange(j)) then
               selvec(i)=1
               qrange(j)=.true.
               goto 500
            endif
         enddo 
 500     continue
      enddo 
c
c     2) intervalles non pris en compte : le plus proche mode.
c
      do i=1,nrange
         if (.not.qrange(i)) then
            dfmin=1e+99
            do j=1,nvec
               if (abs(frange(i)-freq(j)).lt.dfmin) then
                  dfmin=abs(frange(i)-freq(j))
                  jmin=j
               endif
               if (abs(lrange(i)-freq(j)).lt.dfmin) then
                  dfmin=abs(lrange(i)-freq(j))
                  jmin=j
               endif
            enddo
            selvec(jmin)=1
         endif                   
      enddo
c
      nmod=0
      fmin=1e+99
      do i=1,nvec
         if (selvec(i).eq.1) then
            nmod=nmod+1
            selvec(nmod)=i
            if (abs(freq(selvec(nmod))).le.fmin) then
               fmin=abs(freq(selvec(nmod)))
            endif
         endif
      enddo
c
      write(6,'(A)') 
     .    ' Trajmod> Frequencies of the selected modes :'
      write(6,'(5F10.4)')
     .     (freq(selvec(i)),i=1,nmod)
c
c*****AIGUILLAGE:
      if (action.eq.'PROJECTION') goto 800
c
      permin=33.35641d0/fmin
      do i=1,nmod
         permod(selvec(i))=33.35641d0/abs(freq(selvec(i)))
      enddo
c
      tpsec=tper*permin
      write(6,'(A,F10.4,A)') 
     .' Trajmod> Period of the lowest-frequency mode : ',
     .            permin,' psec'
      write(6,'(A,F10.4,A)') 
     .'     So, trajectory length is at most: ',tpsec,' psec.'
c
c     E=1/2.(A.w)**2
c     Le signe de l'energie correspond au "sens" du mode.
c
      write(6,'(A,F6.2,A)') 
     .' Trajmod> Energy on each of the modes: ',
     .            emax,' kcal/mole.'
c
      do i=1,nmod
         qmax(selvec(i))=
     .   sign(dsqrt(2.d0*dabs(emax))*wtofreq/abs(freq(selvec(i))),emax)
      enddo
c
      write(6,'(A)') 
     .    ' Trajmod> Amplitudes of the selected modes :'
      write(6,'(5F10.4)')
     .     (qmax(selvec(i)),i=1,nmod)
c
      if (npoints.gt.0) then
      dtpsec=tpsec/float(npoints)
      else
      npoints=1
      dtpsec=tpsec
      endif
      write(6,'(A,F10.5,A)') 
     .    ' Trajmod> dt= ',dtpsec,' psec.'
c
c*****Calcul de trajectoire(s) :
c
      unout=12
      unout2=13
      call string_split(outfil,64,' ',mot,80,nmots)
      call stringcl(mot(1),nlettres)
c
      if (action.eq.'UNE-TRAJECTOIRE') then
          imod=1
          jmod=nmod
          ntraj=1
      else
          imod=nmod+1
          jmod=nmod+1
          ntraj=nmod
      endif
c
      qoutput=.false.
      if (npoints.eq.1) then
         irsmax=0
         nrenum=0
         qoutput=.true.
         ii=0
         nwat=0
         do i=1,natom
c
c           Selection des atomes pour la carte (eau eventuelle):
c
            qowat=(atonam(i).eq.'O'.and.resnam(i).eq.'HOH').or.
     .            (atonam(i).eq.'OH2'.and.resnam(i).eq.'TIP3')
            if (qowat) nwat=nwat+1
            qowat=qowat.and.qaddwat
c
            if (atonam(i).eq.'CA'.or.qowat) then
               ii=ii+1
               selatom(ii)=i
c
c              Numerotation des residus.
c              Ceux des segments suivant le premier sont renumerotes.
c
               if (ires(i).le.irsmax.or.
     .            (qowat.and.ires(i)-irsmax.gt.1)) then
                   ires(i)=irsmax+1
                   irsmax=irsmax+1
                   nrenum=nrenum+1
               else
                   irsmax=ires(i)
               endif
            endif
         enddo
c
         if (ii.le.1) then
            do i=1,natom
               selatom(i)=i
            enddo
            ii=natom
         endif
         nsel=ii
         if (nsel.gt.natmax) then
            qoutput=.false.
            write(6,'(A,I6,A)')
     .      '%Trajmod-W: ',nsel,
     .      ' selected atoms. Too much for map building.'
         endif
         write(6,'(A,I6,A)') ' Trajmod> ',nrenum,
     . ' residues renumbered.'
      endif
 
      do itraj=1,ntraj
 
c     Nom du fichier de sortie:
c     Une trajectoire par mode:
      if (ntraj.eq.nmod) then
          selvec(nmod+1)=selvec(itraj)
          write(lign80,'(I12)') selvec(nmod+1)
          call stringcl(lign80,k)
          outfil2=outfil(1:nlettres)//'_mod'//lign80(1:k)//'.dcd'
          dtpsec=tper*permod(selvec(itraj))/float(npoints)
c     Sinon:
      else
          outfil2=outfil(1:nlettres)//'.dcd'
      endif
 
      cformat="unformatted"
      cstatus="ove"
      call openam(outfil2,cformat,cstatus,unout,.false.,
     .            qinterr,qexist)
 
c     En-tete d'une trajectoire Charmm:
      I0=0
      write(unout) 'CORD',npoints,1,1,npoints,I0,I0,I0,
     .      3*natom-6,I0,
     .      real(dtpsec),I0,I0,I0,I0,I0,I0,I0,I0,I0,I0
      write(unout) ntit,(title(i),i=1,ntit)
      write(unout) natom
c
      ierr=0
      rmsd=0.d0
      do i=1,npoints
         timeps=twopi*float(i)*dtpsec
         rms=0.d0
         do j=1,natom
            xtr(j)=0.d0
            ytr(j)=0.d0
            ztr(j)=0.d0
            jj=3*j-2
            do k=imod,jmod
               kk=selvec(k)
               qmod=qmax(kk)*sin(timeps/permod(kk))
               xtr(j)=xtr(j)+matvec(jj  ,kk)*qmod
               ytr(j)=ytr(j)+matvec(jj+1,kk)*qmod
               ztr(j)=ztr(j)+matvec(jj+2,kk)*qmod
            enddo
            if (qunmass) then
              if (masse(j).le.0.d0) then
                  ierr=ierr+1
                  if (ierr.le.5) then
                      write(6,'(A,I9)') 
     .               '%Trajmod-W: non positive mass for atom ',j
                      write(6,'(A)') 
     .                '            mass is set to one.'
                  else if (ierr.eq.6) then
                      write(6,'(A)') 
     .               '             etc.'
                  endif
                  masse(j)=1.d0
              endif
              xtr(j)=xtr(j)/dsqrt(masse(j))
              ytr(j)=ytr(j)/dsqrt(masse(j))
              ztr(j)=ztr(j)/dsqrt(masse(j))
            endif
            rms=rms+xtr(j)**2.d0+ytr(j)**2.d0+ztr(j)**2.d0
            xtr(j)=xat(j)+xtr(j)
            ytr(j)=yat(j)+ytr(j)
            ztr(j)=zat(j)+ztr(j)
         enddo
         if (rms.gt.0.d0.and.natom.gt.0) then 
             rms=dsqrt(rms/natom)
         else
             rms=0.d0
         endif
         rmsd=rmsd+rms
         write(unout) (real(xtr(k)),k=1,natom)
         write(unout) (real(ytr(k)),k=1,natom)
         write(unout) (real(ztr(k)),k=1,natom)
      enddo
      close(unout)
      write(6,'(A,F12.6)') ' Trajmod> Fluctuations moyennes: ',
     .      rmsd/float(npoints)
c
      if (qunmass) then
      write(6,'(/A,I6,A/A)') 
     .' Trajmod> A ',npoints,
     .' points cartesian trajectory is stored in :',
     .  outfil2
      else
      write(6,'(/A,I6,A/A)') 
     .' Trajmod> A mass-weighted ',npoints,
     .' points cartesian trajectory is stored in :',
     .  outfil2
      endif
c
c     Si un seul point <=> Analyse => Sortie des cartes "de Go":
c    (Convention de Ikura & Go, 1993; amelioration de Seno & Go, 1990)
c
      if (qoutput) then
         write(6,'(A/A)') 
     .       ' Trajmod> Distance map is computed.',
     .       '          Output: residue number, d-, d+'
         kk=index(outfil2,'.dcd')
         outfil2=outfil2(1:kk-1)//'.distp_map'
         outfil3=outfil2(1:kk-1)//'.distm_map'
         cformat="formatted"
         cstatus="ove"
         call openam(outfil2,cformat,cstatus,unout,.false.,
     .               qinterr,qexist)
         cstatus="ove"
         call openam(outfil3,cformat,cstatus,unout2,.false.,
     .               qinterr,qexist)
 
         kk=0
         dmax=0.0
         moy=0.d0
         do i=1,nsel
            ii=selatom(i)
            do j=i+1,nsel
               jj=selatom(j)
               dist=dsqrt((xat(ii)-xat(jj))**2.d0+
     .                    (yat(ii)-yat(jj))**2.d0+
     .                    (zat(ii)-zat(jj))**2.d0)
               dist2=dsqrt((xtr(ii)-xtr(jj))**2.d0+
     .                    (ytr(ii)-ytr(jj))**2.d0+
     .                    (ztr(ii)-ztr(jj))**2.d0)
               distca(i,j)=dist2-dist
               if (distca(i,j).gt.dmax) dmax=distca(i,j)
               distca(j,i)=distca(i,j)
               moy=moy+dabs(distca(i,j))
               kk=kk+1
            enddo
         enddo
         moy=moy/float(kk)
c
         write(6,'(A,I6)') 
     .   ' Trajmod> Number of selected residues = ',nsel,
     .   '          Number of water  molecules  = ',nwat
         write(6,'(A,F12.8)') 
     .   ' Trajmod> Average distance variation  = ',moy,
     .   '          Maximum distance variation  = ',dmax
 
c        Critere: >moyenne ou <(-moyenne)
c        Une carte pour chacun de ces deux cas.
c        Carte symetrique: plus claire ?
 
         k=0
         factmoy=1.d0
         write(6,'(A,F12.8)') 
     .   ' Trajmod> Selection criterion (/Mean) = ',factmoy
         do i=1,nsel
            ii=ires(selatom(i))
            do j=1,nsel
               jj=ires(selatom(j))
               if (distca(i,j).gt.factmoy*moy) then
                   k=k+1
                   write(unout,'(2I6)') ii,jj
               else if (distca(i,j).lt.-factmoy*moy) then
                   k=k+1
                   write(unout2,'(2I6)') ii,jj
               endif
            enddo
         enddo 
         write(6,'(A,I10)')
     .   ' Trajmod> Number of points in the maps = ',k
         close(unout)
 
      endif
c
c*****Trajectoire (eventuelle) suivante:
c
      enddo
c
      goto 900
c                             ->              ------->
c*****Calcul des projections: dr(fichier pdb).vecteurs
c     action='PROJECTION'
c
 800  continue
c
c     1) Denombrement des atomes pris en compte:
c     (critere: masse et coordonnees non nulles)
c
      j=0
      k=0
      moy=0.d0
      rmsd=0.d0
      rnorm=0.d0
      do i=1,natom
         if (xat(i).eq.0.d0.and.yat(i).eq.0.d0.and.zat(i).eq.0.d0)
     .       masse(i)=0.d0
         if (masse(i).eq.0.d0) j=j+1
         if (masse(i).lt.0.d0) then
             k=k+1
             masse(i)=0.d0
         endif
         moy=moy+masse(i)
         rnorm=rnorm+(xat(i)**2.D0+yat(i)**2.D0+zat(i)**2.D0)*
     .         masse(i)
         rmsd=rmsd+xat(i)**2.D0+yat(i)**2.D0+zat(i)**2.D0
      enddo
      rnorm=dsqrt(rnorm)
      write(6,'(A,I6,A)') ' Trajmod> ',j,' null-mass atoms.'
      write(6,'(A,I6,A)') 
     .    ' Trajmod> ',k,' negative-mass atoms (not considered).'
      natuse=natom-j-k
c
c     2) Etude (eventuelle) des sous-vecteurs propres consideres:
c     (critere: resultats tiennent dans une ligne => 20 vecteurs au max)
c
      if (nmod.le.20) then
      do i=1,nmod
         ii=selvec(i)
         do j=i,nmod     
            jj=selvec(j)
            cosvec(i,j)=0.d0
            do k=1,natom
               if (masse(k).gt.0.d0) then
                   kk=3*(k-1)
                   cosvec(i,j)=cosvec(i,j)+
     .                         matvec(kk+1,ii)*matvec(kk+1,jj)+
     .                         matvec(kk+2,ii)*matvec(kk+2,jj)+
     .                         matvec(kk+3,ii)*matvec(kk+3,jj)
               endif
            enddo
            cosvec(j,i)=cosvec(i,j)
         enddo
         if (cosvec(i,i).le.0.d0) cosvec(i,i)=0.0001d0
      enddo
      write(6,'(A)') ' Trajmod> Cosine matrix of eigenvectors: '
      do i=2,nmod
         write(6,'(20F4.2)') 
     .  (cosvec(i,j)/dsqrt(cosvec(i,i)*cosvec(j,j)),j=1,i-1) 
      enddo
      else
      write(6,'(A)') 
     .    ' Trajmod> More than 20 vectors. No detailled study.'
      endif 
c
c     3) Affichage des donnees caracteristiques:
c
      write(6,'(A,I6,A)') ' Trajmod> ',natuse,' usefull atoms.'
      write(6,'(A,F8.2)') ' Trajmod> Average mass= ',
     .                      moy/float(natuse)
      write(6,'(A,F8.2)') ' Trajmod> Vector r.m.s-norm= ',
     .                      dsqrt(rmsd/float(natuse))
      write(6,'(A,F8.2)') ' Trajmod> Vector mass-r.m.s-norm= ',
     .                      dsqrt(rnorm**2.d0/float(natuse))
c
c     4) Cosinus(vecteur "pdb",vecteurs propres):
c
      sumdr=0.d0
      do i=1,nmod
         kk=selvec(i)
         qnorm=0.d0
         qmax(i)=0.d0
         do j=1,natom
            jj=3*(j-1)
            if (masse(j).gt.0.d0) then
            qmax(i)=qmax(i)+
     .              matvec(jj+1,kk)*xat(j)*dsqrt(masse(j))+
     .              matvec(jj+2,kk)*yat(j)*dsqrt(masse(j))+
     .              matvec(jj+3,kk)*zat(j)*dsqrt(masse(j)) 
            qnorm=qnorm+matvec(jj+1,kk)**2.D0+matvec(jj+2,kk)**2.D0+
     .              matvec(jj+3,kk)**2.D0
            endif
         enddo
         if (qnorm.gt.0.d0) then
             qnorm=dsqrt(qnorm)
             sumdr=sumdr+(qmax(i)/(rnorm*qnorm))**2.d0
c
             write(6,'(I5,A,F6.2,A,F8.4,A,F8.2,2(A,F6.2),A,F8.4)')
     .         kk,
     .       ' Freq= ',freq(kk),
     .       ' Cos= ',qmax(i)/(rnorm*qnorm),
     .       ' Q= ',qmax(i),
     .       ' E= ',0.5d0*(qmax(i)*freq(kk)/wtofreq)**2.d0,
     .       ' %dr2= ',sumdr*100.d0,
     .       ' Qnorm= ',qnorm
         else
             write(6,'(3(A,F10.4))') ' Freq= ',freq(kk),
     .       ' cm-1.  **Null eigenvector norm** '
         endif
      enddo
c
 900  continue
      write(6,'(2A)') program,' Normal end.'
      stop
      end
c
c     Lecture de noms de fichier + Ouverture.
c     Serie de routines utilitaires:
c     openam
c     stringcl
c     string_split
c     Version 1.11, Bordeaux.
c
      SUBROUTINE openam(namfil,cformat,cstatus,unit,qverbos,
     .                  qinterr,qexist)
c
c     Ouverture d'un fichier de nom NAMFIL, sur l'unite UNIT.
c
c     input:
c        namfil: nom du fichier a ouvrir. 
c        "stop", "end", "fin", "quit" : arretent le programme.
c        cstatus: mots-cles fortran... ou "OVE" pour overwrite.
c     output: 
c        qexist: flag / existence du fichier 
c        qinterr: Pas de nom pour le fichier cherche.
c
c     YHS-oct-1993: Premiere version.
c     YHS-jan-2000: Derniere modification.
c I/O:
      logical qinterr, qverbos, qexist
      integer unit
      character*10 cformat, cstatus
      character*64 namfil
c Local
      character*132 ordrunix
c begin:
      if (cstatus.eq.'old') cstatus='OLD'
      if (cstatus.eq.'new') cstatus='NEW'
      if (cstatus.eq.'ove') cstatus='OVE'
      if (cstatus.eq.'unknown') cstatus='UNKNOWN'
c
      qinterr=.false.
      qexist=.false.
c
      if (namfil.eq.' ') then 
          qinterr=.true.
          write(6,'(A)') '%Openam-Err> No filename.'
          return
      endif
c
      if (namfil.eq.'stop'.or.namfil.eq.'end'                         
     &    .or.namfil.eq.'fin'.or.namfil.eq.'quit') then 
         write(*,*) 'Openam> Program is stopping on user request.'
         stop                                                                   
      endif 
c
c     Checks if filename is consistent with the opening:
c
      inquire(file=namfil,exist=qexist)
      if (.not.qexist.and.cstatus.eq.'OLD') then
          qinterr=.true.
          write(6,'(/2A)') '%Openam-Err> File: ',namfil
          write(6,'(A)') '%Openam-Err> Not found.'
          return
      endif
c
      if (qexist.and.cstatus.eq.'NEW') then
         write(*,'(/A)') 
     .      '%Openam-Err> This file exists:',namfil
         stop
      else if (qexist.and.cstatus.eq.'OVE') then
         ordrunix='rm '//namfil
         call system(ordrunix)
      endif
      if (cstatus.eq.'OVE') cstatus='NEW'
c                                                                   
      if (qverbos) then
         write(*,'(/A,I6,A)')
     .           ' Openam> file on opening on unit ',unit,':'
         write(*,*) namfil
      endif
      open(file=namfil,form=cformat,
     .     status=cstatus,unit=unit)                
c        
      return                                                                       
      end
c
      subroutine string_split(chaine,taille,delimiteur,
     .                        souschaine,nbremax,nbre)
c
c     "Chaine" est coupee en "nbre" "souschaine" de part et d'autre du
c     "delimiteur"
c      YHS-Sep-93, Uppsala
c I/O:
      integer taille, nbremax, nbre
      character*(*) chaine, souschaine(*), delimiteur
c Local:
      integer icar, iprev
c
      nbre=1
      iprev=1
      souschaine(1)=chaine
      do icar=1,taille
         if (chaine(icar:icar).eq.delimiteur) then
            if (icar-1.ge.iprev) then
               souschaine(nbre)=chaine(iprev:icar-1)
               nbre=nbre+1
               if (nbre.le.nbremax) then
                  if (icar+1.le.taille.and.
     .               chaine(icar+1:taille).ne.' ') then
                     souschaine(nbre)=chaine(icar+1:taille) 
                  else
                     nbre=nbre-1
                     return
                  endif
               else
                  write(6,'(A,I6,A/A)') 
     .               ' %String_split-Err: more than ',nbremax,
     .               ' substrings in : ',chaine
                  return
               endif
            endif
            iprev=icar+1
         endif
      enddo
c
      return
      end
c
      subroutine stringcl(chaine,nonblancs)
c
c     Les caracteres "blancs" de la CHAINE sont retires (a gauche et au milieu).
c     L'entier NONBLANCS donne la position du dernier caractere.
c
c     YHS-Jan-95, Toulouse.
c     YHS-Oct-00, Bordeaux.
c I/O:
      integer nonblancs
      character*(*) chaine
c Local:
      integer icar, ncar, taille
c Begin:
      nonblancs=0
      taille=len(chaine)
      if (taille.le.0) return
c
      if (index(chaine(1:taille),' ').le.0) then
          nonblancs=taille
          return
      endif
c
c*****Nettoyage des blancs a gauche.
c     Premier non-blanc:
c
      do icar=1,taille
         if (chaine(icar:icar).ne.' ') goto 150
      enddo
      icar=taille
 150  continue
      chaine=chaine(icar:taille)
c
c*****Nettoyage des blancs au milieu.
c
          icar=1
          ncar=1
 170      continue
          icar=icar+1
          ncar=ncar+1
          if (chaine(icar:icar).eq.' ') then
              chaine=chaine(1:icar-1)//chaine(icar+1:taille) 
              icar=icar-1
          endif
          if (ncar.lt.taille-1) goto 170
c
      nonblancs=index(chaine,' ')-1
c
      return
      end
