      program Transmod
c
c     Traduction d'un fichier de vecteurs propres:
c     Vecteurs CHARMM -> Vecteurs CERFACS.
c
c     YHS-Fervier-2002: Premiere version, from check_modes, v1.00.
c
      implicit none
      integer  natmax, nvecmx
      parameter(natmax=10000,nvecmx=106)
      integer i, ii, istr, istp, ivec, j, jj, k,
     .        lnomcfx, lnomeig, natom, nddl,
     .        nord, nunit, nvec,
     .        uncfx, uneig, unout 
      double precision coll, ev(3*natmax), freq(3*natmax), 
     .       masses(natmax), matvec(3*natmax,nvecmx),
     .       norme, normtot, rsmall
      logical qexist, qinter, qok
      character cformat*12, cstatus*12, nomcfx*64, nomeig*64,
     .       program*10, progrer*13, progrwn*13, version*40
 
      version=' Version 1.01, Bordeaux.'
      program=' Transmod>'
      progrwn='%Transmod-Wn>'
      progrer='%Transmod-Er>'
 
      rsmall=1e-4
 
      write(6,'(2A)') program,version
 
      call getnam('Charmm input eigenvector filename ?',
     .     nomeig,lnomeig,qok)
      if (.not.qok) stop
 
      call getnum('First mode read ?',istr,1,3*natmax,.true.,qok)
      call getnum('Last mode read ?',istp,istr,3*natmax,.true.,qok)

      call getnam('Cerfacs output eigenvector filename ?',
     .     nomcfx,lnomcfx,qok)
      if (.not.qok) stop
 
      nunit=10
      uneig=nunit
      nunit=nunit+1
      cformat="UNFORMATTED"
      cstatus="old"
      call openam(nomeig,cformat,cstatus,uneig,.true.,
     .            qinter,qexist)
      if (qinter.or..not.qexist) stop
 
      uncfx=nunit
      nunit=nunit+1
      cformat="FORMATTED"
      cstatus="ove"
      call openam(nomcfx,cformat,cstatus,uncfx,.true.,
     .            qinter,qexist)
      if (qinter) stop
 
c     Lecture:
c     -------
      cformat="UNFORMATTED"
      write(6,'(/2A)') program,' Charmm eigenvector file to be read:'

      call RDNMD(cformat,nvec,3*natmax,nord,
     .     matvec,masses,freq,ev,uneig,ISTR,ISTP)

      write(6,'(A,I6,A)') program,nvec,' vectors to be translated.'
      write(6,'(/2A)') program,' Frequencies:'
      write(6,'(5F12.5)') (freq(i),i=1,nvec)
 
c     Ecriture des modes normaux au format 'CERFACS':
c     -----------------------------------------------
      do i=1,nvec
         write(uncfx,'(A,I5,7X,A,1PG12.4)') 
     .       ' VECTOR',i,'VALUE',ev(i)
         write(uncfx,'(1X,35(1H-))') 
         write(uncfx,'(3(1PG12.4))') 
     .        (matvec(j,i),j=1,nord)
      enddo
c
      write(6,'(/2A)') program,' Normal end.'
 
      stop
      end
c
      subroutine getnam(message,nomlu,lnomlu,qok)
c
c     NOMLU obtenu en reponse au MESSAGE.
c     NTRYMX essais en cas de probleme.
c     YHS-oct-96
c
      implicit none
cI/O:
      integer lnomlu
      logical qok
      character*(*) message
      character*64  nomlu
cLocal:
      integer ntry, ntrymx
cBegin:
      ntrymx=5
c
      qok=.false.
      ntry=0
c
 100  continue
      ntry=ntry+1
      if (ntry.ge.ntrymx) return
c
      write(6,'(A,A)') ' Getnam> ',message
      read(5,'(A)',end=200,err=100) nomlu
c
      call stringcl(nomlu,lnomlu)
      write(6,'(A,A)') ' Getnam> ',nomlu(1:lnomlu)
c
      qok=.true.
      return
 200  continue
      return
      end 
c
      SUBROUTINE openam(namfil,cformat,cstatus,unit,qverbos,
     .                  qinterr,qexist)
c
c     Ouverture d'un fichier de nom NAMFIL, sur l'unite UNIT.
c
c     input:
c        namfil: nom du fichier a ouvrir. 
c        "stop", "end", "fin", "quit" : arretent le programme.
c        cstatus: mots-cles fortran... ou "OVE" pour overwrite.
c     output: 
c        qexist: flag / existence du fichier 
c        qinterr: Pas de nom pour le fichier cherche.
c
c     YHS-oct-1993: Premiere version.
c     YHS-jan-2000: Derniere modification.
c I/O:
      logical qinterr, qverbos, qexist
      integer unit
      character*12 cformat, cstatus
      character*64 namfil
c Local
      character*132 ordrunix
c begin:
      if (cstatus.eq.'old') cstatus='OLD'
      if (cstatus.eq.'new') cstatus='NEW'
      if (cstatus.eq.'ove') cstatus='OVE'
      if (cstatus.eq.'unknown') cstatus='UNKNOWN'
c
      qinterr=.false.
      qexist=.false.
c
      if (namfil.eq.' ') then 
          qinterr=.true.
          write(6,'(A)') '%Openam-Err> No filename.'
          return
      endif
c
      if (namfil.eq.'stop'.or.namfil.eq.'end'                         
     &    .or.namfil.eq.'fin'.or.namfil.eq.'quit') then 
         write(*,*) 'Openam> Program is stopping on user request.'
         stop                                                                   
      endif 
c
c     Checks if filename is consistent with the opening:
c
      inquire(file=namfil,exist=qexist)
      if (.not.qexist.and.cstatus.eq.'OLD') then
          qinterr=.true.
          write(6,'(A)') '%Openam-Err> File not found.'
          return
      endif
c
      if (qexist.and.cstatus.eq.'NEW') then
         write(*,'(/A)') 
     .      '%Openam-Err> This file exists:',namfil
         stop
      else if (qexist.and.cstatus.eq.'OVE') then
         ordrunix='rm '//namfil
         call system(ordrunix)
      endif
      if (cstatus.eq.'OVE') cstatus='NEW'
c                                                                   
      if (qverbos) then
         write(*,'(/A,I6,A)')
     .           ' Openam> file on opening on unit ',unit,':'
         write(*,*) namfil
      endif
      open(file=namfil,form=cformat,
     .     status=cstatus,unit=unit)                
c        
      return                                                                       
      end
c
      subroutine string_split(chaine,taille,delimiteur,
     .                        souschaine,nbremax,nbre)
c
c     "Chaine" est coupee en "nbre" "souschaine" de part et d'autre du
c     "delimiteur"
c      YHS-Sep-93, Uppsala
c I/O:
      integer taille, nbremax, nbre
      character*(*) chaine, souschaine(*), delimiteur
c Local:
      integer icar, iprev
c
      nbre=1
      iprev=1
      souschaine(1)=chaine
      do icar=1,taille
         if (chaine(icar:icar).eq.delimiteur) then
            if (icar-1.ge.iprev) then
               souschaine(nbre)=chaine(iprev:icar-1)
               nbre=nbre+1
               if (nbre.le.nbremax) then
                  if (icar+1.le.taille.and.
     .               chaine(icar+1:taille).ne.' ') then
                     souschaine(nbre)=chaine(icar+1:taille) 
                  else
                     nbre=nbre-1
                     return
                  endif
               else
                  write(6,'(A,I6,A/A)') 
     .               ' %String_split-Err: more than ',nbremax,
     .               ' substrings in : ',chaine
                  return
               endif
            endif
            iprev=icar+1
         endif
      enddo
c
      return
      end
c
      subroutine stringcl(chaine,nonblancs)
c
c     Les caracteres "blancs" de la CHAINE sont retires (a gauche et au milieu).
c     L'entier NONBLANCS donne la position du dernier caractere.
c
c     YHS-Jan-95, Toulouse.
c     YHS-Oct-00, Bordeaux.
c I/O:
      integer nonblancs
      character*(*) chaine
c Local:
      integer icar, ncar, taille
c Begin:
      nonblancs=0
      taille=len(chaine)
      if (taille.le.0) return
c
      if (index(chaine(1:taille),' ').le.0) then
          nonblancs=taille
          return
      endif
c
c*****Nettoyage des blancs a gauche.
c     Premier non-blanc:
c
      do icar=1,taille
         if (chaine(icar:icar).ne.' ') goto 150
      enddo
      icar=taille
 150  continue
      chaine=chaine(icar:taille)
c
c*****Nettoyage des blancs au milieu.
c
          icar=1
          ncar=1
 170      continue
          icar=icar+1
          ncar=ncar+1
          if (chaine(icar:icar).eq.' ') then
              chaine=chaine(1:icar-1)//chaine(icar+1:taille) 
              icar=icar-1
          endif
          if (ncar.lt.taille-1) goto 170
c
      nonblancs=index(chaine,' ')-1
c
      return
      end
c
      subroutine getnum(message,numlu,nummin,nummax,qcheck,qok)
c
c     NUMLU obtenu en reponse au MESSAGE.
c
c     qcheck=.true. =>
c     NUMLU doit etre inferieur a nummax et superieur a nummin.
c
c     NTRYMX essais en cas de probleme.
c     qok=.false. => Probleme a la lecture.
c
c     YHS-oct-1996: version 1.0
c     YHS-jan-2001: version 4.0
c
      implicit none
cI/O:
      integer numlu, nummax, nummin
      logical qok, qcheck
      character*(*) message
cLocal:
      integer ntry, ntrymx, iread
cBegin:
      ntrymx=5
c
      qok=.false.
      ntry=0
c
 100  continue
      ntry=ntry+1
      if (ntry.ge.ntrymx) return
c
      write(6,'(A,A)') ' Getnum> ',message
      read(5,*,end=200,err=100) iread
      numlu=iread
c
      write(6,*) 'Getnum> ',numlu
c
      if (qcheck) then
      if (numlu.gt.nummax) then
          write(6,'(A,I6,A)') 
     .  '%Getnum-Err: number larger than ',nummax,
     .  ' This is not allowed. Sorry.'
          numlu=nummax
          return
      else if (numlu.lt.nummin) then
          write(6,'(A,I6,A)') 
     .  '%Getnum-Err: number smaller than ',nummin,
     .  ' This is not allowed. Sorry.'
          numlu=nummin
          return
      endif
      endif
c
      qok=.true.
      return
 200  continue
      return
      end 

      SUBROUTINE RDNMD(cformat,NFREQ,NAT3,NDIM,
     2     DDV,DDSCR,DDF,DDEV,IUNNMD,ISTR,ISTP)
C
C      READS IN A NORMAL MODE FILE THAT IS PRESENT
C
C     By Bernard R. Brooks    1982
c     Simplifiee, adaptee, par YHS, 2002.
C
      implicit none
      INTEGER i, ICNTRL(20), ISTOP, ISTR, ISTRT, ISTP, IUNNMD,  
     .       j, NAT3, NFREQ,NDIM, ntit
      double precision cnvfrq, DDEV(*), DDF(*), DDSCR(*), DDV(NAT3,*)
      CHARACTER cformat*12, HDR*4, HDRN*4, program*9, progrer*12, 
     .       title(100)*80
      DATA HDRN/'NMDS'/
      cnvfrq=2045.5/(2.99793*6.28319)
 
      program=' Rdchmod>'
      progrer='%Rdchmod-Er>'
      ISTRT=1

c     Lecture de l'en-tete du fichier:
 
      IF(cformat.eq.'FORMATTED') THEN
         i=0
  20     continue
         i=i+1
         READ(IUNNMD,'(A)') title(i)
         write(6,'(A)') title(i)
         if (i.eq.1.or.title(i-1).ne.'*') goto 20 
         ntit=i-1
         READ(IUNNMD,35) ICNTRL
  35     FORMAT(20I5)
      ELSE
         READ(IUNNMD) HDR,ICNTRL
         IF(HDR.NE.HDRN) THEN
            WRITE(6,45) HDR,HDRN
  45        FORMAT(/' **** ERROR **** HEADERS DONT MATCH  ',A4,3X,A4)
            stop
         ENDIF
         read(IUNNMD) ntit,(title(i),i=1,ntit)
         do i=1,ntit
            write(6,'(A)') title(i)
         enddo
      ENDIF
 
      NDIM=3*ICNTRL(3)
      IF(ICNTRL(1).GT.ISTP) ICNTRL(1)=ISTP
      IF(ISTP.GT.ICNTRL(1)) ISTP=ICNTRL(1)
      NFREQ=ISTP-ISTR+ISTRT
      ISTOP=NFREQ

      if (ndim.gt.nat3) then
          write(6,'(/2A,I6,A,I6)') progrer,' Vector dimension: ',ndim,
     .  ' is larger than maximum allowed: ',nat3
          stop
      else 
          write(6,'(/2A,I6)') program,' Vector dimension: ',ndim
          if (ndim.le.0) then
              write(6,'(/2A)') progrer,' Empty eigenvector file ?'
              stop
          endif
      endif

      IF(cformat.eq.'FORMATTED') THEN
         READ(IUNNMD,36) (DDSCR(J),J=1,ndim/3)
  36     FORMAT(6E20.12)
         IF(ISTR.EQ.1) THEN
            READ(IUNNMD,36) (DDEV(J),J=ISTRT,ISTOP)
         ELSE
            READ(IUNNMD,36) (DDSCR(J),J=1,ISTR-1),
     &      (DDEV(J),J=ISTRT,ISTOP)
            DO I=1,ISTR-1
               READ(IUNNMD,36)
            ENDDO
         ENDIF
         DO I=ISTRT,ISTOP
            READ(IUNNMD,36) (DDV(J,I),J=1,Ndim)
         ENDDO
      ELSE
         READ(IUNNMD) (DDSCR(J),J=1,ndim/3)
         IF(ISTR.EQ.1) THEN
            READ(IUNNMD) (DDEV(J),J=ISTRT,ISTOP)
         ELSE
            READ(IUNNMD) (DDSCR(J),J=1,ISTR-1),
     &                   (DDEV(J),J=ISTRT,ISTOP)
            DO I=1,ISTR-1
               READ(IUNNMD)
            ENDDO
         ENDIF
         DO I=ISTRT,ISTOP
            READ(IUNNMD) (DDV(J,I),J=1,Ndim)
         ENDDO
      ENDIF
 
      DO I=ISTRT,ISTOP
         DDF(I)=CNVFRQ*SQRT(ABS(DDEV(I)))
         IF(DDEV(I).LT.0.0) DDF(I)=-DDF(I)
      ENDDO
 
      RETURN
      END
