      PROGRAM DIAG
c
c     Traduction de matrices.
c
c     Matrices lues, en provenance de (detectees, dans cet ordre):
c     CHARM24 -Matrice des derivees secondes, binaire   (pleine)  : matrice.sdch24
c     CHARM21 -Matrice des derivees secondes, binaire, compressee : matrice.sdch21
c     CERFACS -Matrice des derivees secondes, formattee (creuse)  : matrice.sdij 
c     CERFACS -Matrice des derivees secondes, formattee (creuse)  : matrice.sdijf
c     CERFBIN -Matrice des derivees secondes, binaire   (creuse)  : matrice.sdijb
c     XPMOD   -Matrice des derivees secondes, formattee (pleine)  : matrice.sdf
c
c     Ecriture de la matrice des derivees secondes:
c     Charmm -> CERFACS formatte
c     Charm24-> CERFACS formatte ou binaire (qbinary)
c     Format de sortie :
c     CERFACS: I, J, DDJ (format libre)                           : matrice.sdijf
c     CERFACS: I, J, DDJ (binaire)                                : matrice.sdijb
c
c     Routines utilisees:
c     diagq  -from Charmm_20 (xplor): qq vecteurs/ALMAT 
c            (demi-matrice superieure linearisee)
c
c     Parametres importants:
c     Nvecmx:  le nombre de vecteurs propres calcules.
c     Natdiag: le nombre maximum d'atomes du systeme pour lequel 
c              on peut faire la diagonalisation.
c     Natmax:  le nombre maximum d'atomes du systeme etudie
c    (si l'on ne peut diagonaliser, on peut changer le format de la matrice,
c     ce qui est utile pour transferer des matrices binaires).
c
c     Sortie des vecteurs propres :
c     Format CERFACS                                              : matrice.eigenfacs
c
c     YHS-Janvier-1994: premiere version.
c     YHS-Janvier-2001: dernieres modifications.
 
      implicit none
      integer natmax, ndim, nldim, mxnonb, mxexcl, mxextr, nvecmx
      integer natdiag, ncontmax, ndimvec
 
c.....Limitant: Natdiag (via mat(ndim,*), ou almat(nldim) ...)
C     Nldim definit aussi la taille du fragment de la matrice
c     traite lorsque la matrice est juste traduite (MAKWSD).
c.....Natdiag=1800 (grand) <=> version Cray-C9X
c.....Natdiag=950  (petit) <=> version station de travail
c     Natmax=5000 utilises sur la station/citrate...
 
c     Version xpcjuan (PC/Linux):
      parameter(natmax=1600,ncontmax=natmax*(natmax+1)/2)
      parameter(natdiag=10,nvecmx=1)

c.....Quelques choix precedemment faits:
c     Version xpcjuan (PC/Linux):
c     parameter(natmax=1600,ncontmax=natmax*(natmax+1)/2)
c     parameter(natdiag=1600,nvecmx=106)
c     Version hpcal (HP/Unix) -pas assez de memoire vive:
c     parameter(natmax=1000,ncontmax=natmax*(natmax+1)/2)
c     parameter(natdiag=1000,nvecmx=50)
c
c     Diagonalisation complete d'une matrice pleine:
c     parameter(natdiag=950,nvecmx=3*natdiag)
c     parameter(natmax=950,ncontmax=natmax*(natmax+1)/2)
 
      parameter(ndim=3*natdiag,nldim=ndim*(ndim+1)/2)
      parameter(ndimvec=ndim*nvecmx)
      parameter(mxnonb=ncontmax/20,mxexcl=ncontmax/200,mxextr=mxexcl)
c
c.....Necessaire (et que pour cela)/ Lecture matrice formattee xpmod:
c
      double precision mat(ndim,1)
c
      logical qdiag, qbinary, qlist, qinterr, qexist
      integer natom, nvec, nadd, njnb, ninb, ndd4,
     .        inblo(natmax), iblo(natmax), jvois, jatvois(natmax),
     .        ICNTRL(20), ntit, nelmnts,
     .        idimsd, rdunit, nord, unmess, unwrit, unvois, unmodes,
     .        nbig, nredond, ntrace
      integer i, ii, j, jj, k, jmin, jminex, jpoint
      integer*2 idd4(mxextr), jdd4(mxextr)
      integer*2 inb(mxexcl), jnb(mxnonb)
      real amass(natmax), dd2(6*mxnonb), dd3(9*mxexcl), dd4(9*mxextr)
      double precision almat(nldim), dd1(6*natmax), masses(natmax),
     .       eigvec(ndimvec), rcreux, matrd, trace, masscoor(3*natmax),
     .       levelshft
      CHARACTER*4 HDRS
      character*9 program
      character*10 progrwn
      character*20 matrice, cformat, cstatus, nomfich
      character*32 version
      integer ntitmx
      parameter(ntitmx=100)
      CHARACTER*80 title(ntitmx)
C
c     Tableaux de travail pour la diagonalisation:
      DOUBLE PRECISION A(ndim+1), B(ndim+1), P(ndim+1)
      DOUBLE PRECISION W(ndim+1), EV(ndim+1)
      DOUBLE PRECISION TA(ndim+1),TB(ndim+1),Y(ndim+1)
c
      version=' Version 2.24, Bordeaux.'
      program=' Diagmat>'
      progrwn='%Diagmat-W'
c Debut:
c     La diagonalisation sera faite...
c     Si la taille de la matrice est compatible 
c     avec celle des tableaux.
 
      qdiag=.false.
      qbinary=.false.
 
      write(6,'(2A)') program,version
 
      qlist=.false.
c     rcreux=-1.d0
      rcreux=1.E-10
      levelshft=1.e-6
 
      nvec=nvecmx
      nadd=0
 
c     Sorties:
      unwrit=11
      unvois=12
      unmodes=13
 
c     Sortie standard: 
      unmess=6
 
      write(unmess,'(2A)') program,
     .     " Lecture d'une matrice "

      if (qdiag) then
      write(6,'(2A)') program,
     .    ' Si possible, diagonalisation. '
      else
      write(6,'(2A)') program,' Simple traduction.'
      endif
 
c*****Detection de la matrice d'entree:
 
      rdunit=10
      nomfich='matrice.sdch21'
      cformat='UNFORMATTED'
      cstatus='OLD'
      call openam(nomfich,cformat,cstatus,
     .     rdunit,.false.,
     .     qinterr,qexist)
      if (qexist) then
          matrice='CHARM21'
      else
      nomfich='matrice.sdch24'
      call openam(nomfich,cformat,cstatus,
     .     rdunit,.false.,
     .     qinterr,qexist)
      if (qexist) then
          matrice='CHARM24'
      else
      nomfich='matrice.sdijb'
      call openam(nomfich,cformat,cstatus,
     .     rdunit,.false.,
     .     qinterr,qexist)
      if (qexist) then
          matrice='CERFBIN'
      else
      nomfich='matrice.sdijf'
      cformat='FORMATTED'
      call openam(nomfich,cformat,cstatus,
     .     rdunit,.false.,
     .     qinterr,qexist)
      if (qexist) then
          matrice='CERFACS'
      else
      nomfich='matrice.sdij'
      call openam(nomfich,cformat,cstatus,
     .     rdunit,.false.,
     .     qinterr,qexist)
      if (qexist) then
          matrice='CERFACS'
      else
      nomfich='matrice.sdf'
      call openam(nomfich,cformat,cstatus,
     .     rdunit,.false.,
     .     qinterr,qexist)
      if (qexist) then
          matrice='XPMOD'
      else
          matrice='NONE'
          write(unmess,'(A)')
     .'%Diag_Err: Matrice des derivees secondes non trouvee.',
     .' Noms possibles: ',
     .' matrice.sdijf  (CERFACS) -formattee, creuse, format libre-',
     .' matrice.sdij   (CERFACS) -formattee, creuse, format libre-',
     .' matrice.sdf    (XPMOD)   -formattee, pleine-',
     .' matrice.sdijb  (CERFBIN) -non formattee, creuse, format libre-',
     .' matrice.sdch21 (CHARM21) -non formattee, creuse, compressee-',
     .' matrice.sdch24 (CHARM24) -non formattee, pleine-'
          stop
      endif
      endif
      endif
      endif
      endif
      endif
c
      write(6,'(3A)') program,' Fichier trouve: ',nomfich
c
      do i=1,nldim
         almat(i)=0.d0
      enddo
c
c*****Lecture matrice d'entree (CHARM21, CERFACS, CERFBIN, XPMOD):
c.....1) XPMOD (formattee, pleine):
c
      if (matrice.eq.'XPMOD') then
      write(unmess,'(2A)') program,
     .     ' Lecture de la matrice -Format XPMOD- '
c
      idimsd = nldim 
      CALL RSECF2(mat,ndim,ALMAT,IDIMSD,nord,rdunit,'LOWE')
c
      goto 5000
      endif
c
c.....2) CERFACS, CERFBIN (formattee, creuse):
c
      if (matrice.eq.'CERFACS'.or.matrice.eq.'CERFBIN') then
      write(unmess,'(2A)') program,
     .     ' Lecture de la matrice -Format CERFACS- '
c
c     Ordre de la matrice:
c     --------------------
      k=0
      nord=0
  90  continue
      if (matrice.eq.'CERFACS') then
      read(rdunit,*,end=100) i,j
      else
      read(rdunit,end=100) i,j
      endif
      k=k+1
      if (i.gt.nord) nord=i
      if (j.gt.nord) nord=j
      goto 90
 100  continue
      write(unmess,'(A,I11,A)')
     .     ' Diag: ',k,' elements lus.'
      write(unmess,'(A,I6)')
     .     ' Diag: Dimension matrice (Nord)= ',nord
      natom=nord/3
      if (natom.gt.natmax.or.nord.gt.ndim.or.k.gt.nldim) then
          write(unmess,'(A)')
     .   '%Diag-Err: Lecture de la matrice impossible.'
          if (natom.gt.natmax) write(unmess,'(2(A,I9))')
     .   ' Natom= ',natom,' > natmax= ',natmax
          if (nord.gt.ndim) write(unmess,'(2(A,I9))')
     .   ' Nord=  ',nord,' > Ndim= ',ndim
          if (k.gt.nldim) write(unmess,*)
     .   " Nombre d'elements= ",k,' > Nldim= ',nldim
          stop
      endif
c
c     Lecture de la matrice (linearisee, demi-superieure: j>i):
c     --------------------------------------------------------
      rewind(rdunit)
c
      trace=0.d0
      ntrace=0
      nredond=0
      do jj=1,k
         if (matrice.eq.'CERFACS') then
         read(rdunit,*,err=95) i,j,matrd
         else
         read(rdunit,err=95) i,j,matrd
         endif
c
c        Position de l'element (i,j) dans la matrice linearisee:
c
         if (j.ge.i) then 
             ii=(i-1)*i/2 + (i-1)*(nord-i+1) + j-i+1
         else
             ii=(j-1)*j/2 + (j-1)*(nord-j+1) + i-j+1
         endif
         if (almat(ii).ne.0.d0) then
             nredond=nredond+1
         else
             almat(ii)=matrd
             if (i.eq.j) then 
                trace=trace+matrd
                ntrace=ntrace+1
             endif
         endif
      enddo
      goto 105
  95  continue
      write(unmess,*)
     .     '%Diag-Err: Erreur de lecture sur la ligne ',i
      write(unmess,*) ' i,j,matrd= ',i,j,matrd
      stop
 105  continue
c
      write(unmess,'(A,F16.6)')
     .     ' Diag: Trace de la matrice linearisee= ',trace
      write(unmess,'(A,I9)')
     ." Diag: Nombre d'elements non-nuls sur la trace de la matrice= ",
     .  ntrace
      write(unmess,'(A,I9)')
     ." Diag: Nombre d'elements redondants dans la matrice= ",
     .  nredond
      if (nredond.gt.0) write(unmess,'(A/)') ' %Diag-W: Est-ce normal ?'
c
      goto 5000
      endif
c
c.....3) CHARM21 (creuse,compressee,binaire):
c
      if (matrice.eq.'CHARM21') then
      write(unmess,'(/2A)') program,
     .    ' Lecture de la matrice -Format CHARM21- '
c
      call rsdch21(rdunit,unmess,natom,ndd4,
     .     IBLO,INBLO,DD1,natmax,INB,DD3,mxexcl,JNB,DD2,mxnonb,
     .     IDD4,JDD4,DD4,mxextr,AMASS)
      nord=3*natom
c
c     Liste de "tous" les voisins:
c     ----------------------------
      if (qlist) then
          nomfich='molecule.voisins'
          cformat='UNFORMATTED'
          cstatus='UNKNOWN'
          call openam(nomfich,cformat,cstatus,
     .         unvois,.true.,
     .         qinterr,qexist)
c
          write(6,*) 'Atomes non lies: '
          write(6,*) 'Pointeur : '    
          write(6,'(10I6)') (INBLO(I),i=1,natom)
          write(6,'(10I6)') (JNB(J),J=1,njnb)
          write(6,*) 'Atomes exclus: '
          write(6,*) 'Pointeur : '    
          write(6,'(10I6)') (IBLO(I),i=1,natom)
          write(6,'(10I6)') (INB(J),J=1,ninb)
          jpoint=0
          do i=1,natom
             jvois=0
             if (i.eq.1) then 
                 jmin=1
                 jminex=1
             else
                 jmin=inblo(i-1)+1
                 jminex=iblo(i-1)+1
             endif
             do j=jmin,inblo(i)
                 jvois=jvois+1
                 jatvois(jvois)=jnb(j)
                 if (jnb(j).le.0) jatvois(jvois)=-jatvois(jvois)
             enddo
             do j=jminex,iblo(i)
                 do k=jmin,inblo(i)
                    if (inb(j).eq.jnb(k)) goto 150
                 enddo
                 jvois=jvois+1
                 jatvois(jvois)=inb(j)
                 if (inb(j).le.0) jatvois(jvois)=-jatvois(jvois)
 150             continue
             enddo
             jpoint=jpoint+jvois
             write(6,*) 'Atome : ',I
             write(6,*) 'Atomes non lies: '
             write(6,'(10I6)') 
     .            (JNB(J),J=INBLO(I-1)+1,INBLO(I))
             write(6,*) 'Atomes exclus: '
             write(6,'(10I6)') 
     .            (INB(J),J=IBLO(I-1)+1,IBLO(I))
             write(6,*) 'Total: '
             write(6,'(10I6)') 
     .            (jatvois(J),J=1,jvois)
             write(unvois) jvois,(jatvois(J),J=1,jvois)
          enddo
      endif
c
      if (nord.gt.ndim) qdiag=.false.
c
c     Recontruction de la matrice (decompression):
c     -------------------------------------------
c
      if (qdiag) then
      write(unmess,'(A)')
     .    ' Diag: Decompression de la matrice.'
c
      CALL MAKESD(NATOM,3*NATOM,INBLO,JNB,IBLO,INB,AMASS,
     .     DD1,DD2,DD3,NDD4,mxextr,DD4,IDD4,JDD4,almat,unmess)
c
      k=0
      trace=0.d0
      do i=1,nord
         do j=i,nord
            k=k+1
            if (i.eq.j) trace=trace+almat(k)
         enddo
      enddo
      write(unmess,'(A,F16.6)')
     .    ' Diag: Trace de la matrice linearisee= ',trace
      endif
c
c     Sauvetage:
c     ---------
c
      if (.not.qdiag) then
         write(unmess,'(2(A,I6)/A)')
     .     ' Diag: Dimension= ',nord,' Maximum diagonalisable= ',ndim,
     .     '       La matrice est ecrite, formattee.'
         write(unmess,'(A)')
     .     ' Diag: Format=CERFACS.'
         OPEN (unwrit,FILE='matrice.sdijf',STATUS='UNKNOWN')
c
c        Pour le moment: sortie formattee.
         CALL MAKWSD(NATOM,3*NATOM,INBLO,JNB,IBLO,INB,AMASS,
     .        DD1,DD2,DD3,NDD4,mxextr,DD4,IDD4,JDD4,almat,
     .        nldim,rcreux,unmess,unwrit,.false.)
c        Fin:
         goto 9999
      else
         goto 5000
      endif
c
      endif
c
c.....4) CHARM24 (binaire, pleine):
c
      if (matrice.eq.'CHARM24') then
      write(unmess,'(2A)') program,
     .     ' Lecture de la matrice -Format CHARM24- '
c
      read(rdunit) HDRS,ICNTRL
      read(rdunit) ntit,(title(i),i=1,min(ntit,ntitmx))
      nord=ICNTRL(2)
      NATOM=ICNTRL(3)
      write(unmess,'(3A/2A,I6)')
     .      program,' En-tete= ',HDRS,
     .      program,' Dimension matrice= ',nord
      write(unmess,'(A,I6,A)')
     .      program,natom,' atomes (Natom).'
c
      if (natom.gt.natmax.or.nord.gt.ndim) then
          write(unmess,'(A)')
     .   '%Diag-Err: Lecture de la matrice impossible.'
          if (natom.gt.natmax) write(unmess,'(2(A,I9))')
     .   ' Natom= ',natom,' > natmax= ',natmax
          if (nord.gt.ndim) write(unmess,'(2(A,I9))')
     .   ' Nord=  ',nord,' > Ndim= ',ndim
          stop
      endif
c
      nelmnts=nord*(nord+1)/2
      if (nelmnts.gt.nldim) then
          write(unmess,*)
     .  " Nombre d'elements= ",nelmnts,' > Nldim= ',nldim
          stop
      endif
c
      read(rdunit) (almat(I),I=1,nelmnts)
      read(rdunit) (MASSes(I),I=1,NATOM)
c
      do i=1,natom
         ii=3*i-2
         masscoor(ii)=masses(i)
         masscoor(ii+1)=masses(i)
         masscoor(ii+2)=masses(i)
      enddo
c
c     Masse-ponderation de la matrice des derivees secondes:
c
      write(unmess,'(2A)') program,' Mass-ponderation.'
      i=0
      trace=0.d0
      do ii=1,nord
         do jj=ii,nord
            i=i+1
            almat(i)=almat(i)/dsqrt(masscoor(ii)*masscoor(jj))
            if (jj.eq.ii) then
                almat(i)=almat(i)+levelshft
                trace=trace+almat(i)
            endif
         enddo
      enddo
      write(unmess,'(2A,P1G12.4)') program,' Shift= ',levelshft
      write(unmess,'(2A,P1G12.4)') program,' Trace= ',trace
c
      do i=1,natom
         amass(i)=masses(i)
      enddo
c
      goto 5000
      endif
c
 5000 continue
      if (.not.qdiag) then
         write(unmess,'(2A,I6,A)') program,
     .     ' Dimension= ',nord,
     .     ' La matrice est ecrite.'
c
         if (qbinary) then
         nomfich='matrice.sdijb'
         write(unmess,'(2A)') program,
     .     ' Format=CERFACS, binaire.'
         cformat='UNFORMATTED'
         else
         nomfich='matrice.sdijf'
         write(unmess,'(2A)') program,
     .     ' Format=CERFACS, formattee.'
         cformat='FORMATTED'
         endif
c
         cstatus='OVE'
         call openam(nomfich,cformat,cstatus,
     .        unwrit,.true.,qinterr,qexist)
         i=0
         k=0
         nbig=0
         do ii=1,nord
          do jj=ii,nord
            i=i+1
            matrd=almat(i)
            if (dabs(matrd).gt.rcreux) then
                if (qbinary) then
                write(unwrit) ii, jj, matrd            
                else
                write(unwrit,*) ii, jj, matrd            
                endif
                k=k+1
                nbig=nbig+1
                if (dabs(matrd).gt.1E+10) then
                if (nbig.lt.10) then
                 write(unmess,'(2A,I12,A,G12.3)') 
     .                 progrwn,' Element: ',i,' = ',almat(i)
                else 
                 if (nbig.eq.10) write(unmess,*) '...'
                endif
                endif
            endif
          enddo
         enddo
         write(unmess,'(A,I12,A)') 
     .         program,k,' elements written.'
c
         goto 9999
      endif
c
c*****Diagonalisation:
c
      write(unmess,'(/2A)') program,' Diagonalisation.'
c
c     Test sommaire de la matrice:
      nbig=0
      do i=1,nldim
         if (dabs(almat(i)).gt.1E+10) then
             nbig=nbig+1
             if (nbig.lt.10) then
                 write(unmess,'(2A,I12,A,G12.3)') 
     .                 progrwn,' Element: ',i,' = ',almat(i)
             else 
                 if (nbig.eq.10) write(unmess,*) '...'
             endif
         endif
      enddo
      write(unmess,'(2A,I6)') program,
     .     " Nombre d'elements > 1E+10 = ",nbig
c
      nomfich='matrice.eigenfacs'
      cformat='FORMATTED'
      cstatus='NEW'
      call openam(nomfich,cformat,cstatus,
     .     unmodes,.true.,
     .     qinterr,qexist)
c
      if (nvec.gt.nord) nvec=nord
      WRITE(6,'(2(A,I6,A))')
     .' Diag: ',NVEC,' vecteurs propres calcules. ',
     .        'Les ',Nadd,' premiers sont sautes. ',
     .'       Pour une matrice de dimension ',nord
c
c     Initialisations:
      do i=1,ndim
         ev(i)=0.d0
      enddo
      do i=1,ndimvec
         eigvec(i)=0.d0
      enddo
c
      CALL DIAGQ(nord,nvec,almat,eigvec,A,B,P,W,EV,TA,TB,Y,NADD)
c
      trace=0.d0
      do i=1,nvec
         trace=trace+ev(i)
      enddo
      write(unmess,'(2A,F16.6)') program,
     .     ' Somme des valeurs propres= ',trace
c
      write(unmess,'(2A/(5F15.7))') program,
     .    ' Valeurs propres: ',
     .           (ev(I),I=1,NVEC)
      WRITE(unmess,'(/2A/(5F15.7))') program,
     .    ' Frequences harmoniques (en cm-1, '//
     .     'si derivees secondes en unites CHARMM):',
     .    (SQRT(dABS(ev(I)))*108.591365,I=1,NVEC)
c
c*****Ecriture des modes normaux au format 'CERFACS':
c
      do i=1,nvec
         write(unmodes,'(A,I5,7X,A,1PG12.4)') 
     .       ' VECTOR',i,'VALUE',ev(i)
         write(unmodes,'(1X,35(1H-))') 
         write(unmodes,'(3(1PG12.4))') 
     .        (eigvec((i-1)*nord+j),j=1,nord)
      enddo
c
 9999 continue
      write(unmess,'(2A)')
     .      program,' Fin.'
c
      stop 
      end
c----------------------------------------------------------------
      SUBROUTINE openam(namfil,cformat,cstatus,unit,qverbos,
     .                  qinterr,qexist)
c
c     Ouverture d'un fichier de nom NAMFIL, sur l'unite UNIT,
c     a priori suite a une interrogation...
c
c     input:
c        namfil: nom du fichier a ouvrir. 
c        "stop", "end", "fin", "quit" : arretent le programme.
c        cstatus: mots-cles fortran... ou "OVE" pour overwrite.
c     output: 
c        qexist: flag / existence du fichier 
c        qinterr: Pas de nom pour le fichier cherche.
c
c     YHS-oct-93
c     YHS-jan-95
c I/O:
      logical qinterr, qverbos, qexist
      integer unit
      character*(*) namfil, cformat, cstatus
c Local
      character*132 ordrunix
c begin:
      if (cstatus.eq.'old') cstatus='OLD'
      if (cstatus.eq.'new') cstatus='NEW'
      if (cstatus.eq.'ove') cstatus='OVE'
      if (cstatus.eq.'unknown') cstatus='UNKNOWN'
c
      qinterr=.false.
      qexist=.false.
c
      if (namfil.eq.' ') then 
          qinterr=.true.
          write(6,'(A)') '%Openam-Err> No filename.'
          return
      endif
c
      if (namfil.eq.'stop'.or.namfil.eq.'end'                         
     &    .or.namfil.eq.'fin'.or.namfil.eq.'quit') then 
         write(*,*) 'Openam> Program is stopping on user request.'
         stop                                                                   
      endif 
c
c     Checks if filename is consistent with the opening:
c
      inquire(file=namfil,exist=qexist)
      if (.not.qexist.and.cstatus.eq.'OLD') then
          qinterr=.true.
          if (qverbos) write(6,'(A)') '%Openam-Err> File not found.'
          return
      endif
c
      if (qexist.and.cstatus.eq.'NEW') then
         write(*,'(/A)') 
     .      '%Openam-Err> This file exists:',namfil
         stop
      else if (qexist.and.cstatus.eq.'OVE') then
         ordrunix='rm '//namfil
         call system(ordrunix)
      endif
      if (cstatus.eq.'OVE') cstatus='NEW'
c                                                                   
      if (qverbos) then
         write(*,'(/A,I6,A)')
     .           ' Openam> file on opening on unit ',unit,':'
         write(*,*) namfil
      endif
      open(file=namfil,form=cformat,
     .     status=cstatus,unit=unit)                
c        
      return                                                                       
      end
c--------------------------------------------------------------------
      SUBROUTINE DIAGQ(NX,NFRQX,DD,VEC,A,B,P,W,EV,TA,TB,Y,NADD)
C  (from flecs)
C   THIS ROUTINE IS A CONGLOMERATION OF GIVEN, HOUSEC, AND EIGEN
C   WHERE THE BEST FEATURES OF EACH WERE KEPT AND SEVERAL OTHER
C   MODIFICATIONS HAVE BEEN MADE TO INCREASE EFFICIENCY AND ACCURACY.
C   B. R. BROOKS
C
C   NX      - ORDER OF MATRIX
C   NFRQX   - NUMBER OF ROOTS DESIRED
C   DD      - SECOND DERIVATIVE MATRIX IN UPPER TRIANGULAR FORM
C   VEC     - EIGENVECTORS RETURNED (NX,NFRQX)
C   EV      - EIGENVALUES RETURNED (NX)
C   A,B,P,W,TA,TB,Y - ALL SCRATCH VECTORS (NX+1)
C   NADD    - NUMBER OF LOWEST ROOTS TO SKIP
C
      implicit none
      INTEGER NX, NFRQX
      DOUBLE PRECISION DD(1),VEC(1),A(1),B(1),P(1),W(1),EV(1)
      DOUBLE PRECISION TA(1),TB(1),Y(1)
      INTEGER NADD
      INTEGER N, NEV, NEVADD, NTOT, I, IPT, IJ, NN, MI, MI1
      INTEGER JI, JI2, J, ML, II, ML1, L, NOMTCH, IA
      INTEGER KK, M, K, ITER, MJ, J1, MK, MK1, MJ1, NOM
      DOUBLE PRECISION ETA, THETA, STEP, DEL1, DELTA, SMALL
      DOUBLE PRECISION DELBIG, THETA1, TOLER, ACC, RPOWER, RPOW1
      DOUBLE PRECISION RAND1, FACTOR, U, ANORM, ANORMR, SUM1
      DOUBLE PRECISION BX, S, SGN, TEMP, XKAP, ROOTX, ALIMIT
      DOUBLE PRECISION ROOTL, TRIAL, F0, ELIM1, ELIM2
      DOUBLE PRECISION EXPR, T, AROOT, EPR, XNORM, XNORM1, ZERO
      DOUBLE PRECISION ABSYJ
      PARAMETER (ZERO=1.0)
      ETA=1.D-16
      THETA=1.D37
      STEP=0.0
      N=NX
      NEV=NFRQX
      NEVADD=NEV+NADD
      DEL1=ETA/100.0
      DELTA=ETA**2*100.0
      SMALL=ETA**2/100.0
      DELBIG=THETA*DELTA/1000.0
      THETA1=1000.0/THETA
      TOLER=100.0*ETA
      ACC=1.D-8
      RPOWER=8388608.0
      RPOW1=RPOWER*0.5
      RAND1=RPOWER-3.0
      FACTOR=0.0
      NTOT=(N*(N+1))/2
      DO 810 I=1,NTOT
      FACTOR=MAX(FACTOR,ABS(DD(I)))
 810   CONTINUE
      IF(FACTOR.GT.THETA1) GO TO 818
      WRITE(6,811)
 811  FORMAT(' WARNING FROM <DIAGQ>. ZERO MATRIX PASSED.',
     1     ' IDENTITY MATRIX RETURNED.')
      DO 815 I=1,NEV
      EV(I)=0.0
      IPT=(I-1)*N
      DO 815 J=1,N
      IPT=IPT+1
      VEC(IPT)=0.0
      IF(I+NADD.EQ.J) VEC(IPT)=1.0
 815  CONTINUE
      RETURN
 818  CONTINUE
      IJ=0
      ANORM=0.0
      DO 820 I=1,N
      DO 820 J=I,N
      IJ=IJ+1
      U=(DD(IJ)/FACTOR)**2
      IF(I.EQ.J) U=U*0.5
      ANORM=ANORM+U
 820   CONTINUE
      ANORM=SQRT(ANORM+ANORM)*FACTOR
      ANORMR=1.0/ANORM
      DO 830 I=1,NTOT
      DD(I)=DD(I)*ANORMR
 830   CONTINUE
      NN=N-1
      MI = 0
      MI1=N-1
      DO 70 I=1,NN
      SUM1=0.0
      B(I)=0.0
      JI=I+1
      IPT=MI+I
      A(I)=DD(IPT)
      IPT=IPT+1
      BX=DD(IPT)
      JI2=JI+1
      IF(JI.EQ.N)GO TO 11
      DO 10 J=JI2,N
      IPT=IPT+1
      SUM1=SUM1+DD(IPT)*DD(IPT)
  10   CONTINUE
      IF(SUM1.GT.SMALL) GO TO 15
  11   B(I)=BX
      DD(MI+JI)=0.0
      MI=MI+MI1
      MI1=MI1-1
      GO TO 70
  15   CONTINUE
      S = SQRT (SUM1+BX**2)
      SGN=SIGN(ZERO, BX)
      TEMP = ABS(BX)
      W(JI) =SQRT (.5*(1.0+(TEMP/S)))
      IPT=MI+JI
      DD(IPT)=W(JI)
      II=I+2
      IF(II.GT.N) GO TO 22
      TEMP=SGN/(2.0*W(JI)*S)
      DO 20 J=II,N
      IPT=IPT+1
      W(J) = TEMP * DD(IPT)
 20   DD(IPT)=W(J)
 22   B(I) = -SGN*S
      DO 25 J=JI,N
      P(J)=0.0
  25   CONTINUE
      ML = MI + MI1
      ML1=MI1-1
      DO 40 L=JI,N
      IPT=ML+L
      DO 35 M=L,N
      BX=DD(IPT)
      P(L)=P(L)+BX*W(M)
      IF(L.NE.M) P(M)=P(M)+BX*W(L)
      IPT=IPT+1
 35   CONTINUE
      ML = ML +ML1
 40   ML1=ML1-1
      XKAP = 0.0
      DO 45 K=JI,N
 45   XKAP=XKAP+W(K)*P(K)
      DO 50 L=JI,N
 50   P(L)=P(L)-XKAP*W(L)
      MJ = MI + MI1
      MJ1=MI1-1
      DO 60 J=JI,N
      DO 55 K=J,N
      EXPR =(P(J)*W(K))+(P(K) * W(J))
 55   DD(MJ+K)=DD(MJ+K)-EXPR-EXPR
      MJ = MJ + MJ1
 60   MJ1=MJ1-1
      MI = MI + MI1
      MI1 = MI1 - 1
 70   CONTINUE
      A(N)=DD(MI+N)
      B(N)=0.0
      ALIMIT=1.0
      DO 90 I=1,N
      W(I)=B(I)
      B(I)=B(I)*B(I)
  90   CONTINUE
      DO 110 I=1,NEVADD
 110  EV(I)=ALIMIT
      ROOTL=-ALIMIT
      DO 200 I=1,NEVADD
      ROOTX=ALIMIT
      DO 120 J=I,NEVADD
 120   ROOTX=MIN(ROOTX,EV(J))
      EV(I)=ROOTX
 130   TRIAL=(ROOTL+EV(I))*0.5
      IF(TRIAL.EQ.ROOTL.OR.TRIAL.EQ.EV(I)) GOTO 200
 140   CONTINUE
      NOMTCH=N
      J=1
 150   F0=A(J)-TRIAL
 160   CONTINUE
      IF(ABS(F0).LT.THETA1) GOTO 170
      IF(F0.GE.0.0) NOMTCH=NOMTCH-1
      J=J+1
      IF(J.GT.N) GOTO 180
      F0=A(J)-TRIAL-B(J-1)/F0
      GOTO160
 170   J=J+2
      NOMTCH=NOMTCH-1
      IF(J.LE.N) GOTO 150
 180   CONTINUE
      IF(NOMTCH.GE.I) GOTO 190
      ROOTL=TRIAL
      GO TO 130
 190   EV(I)=TRIAL
      NOM=MIN0(NEVADD,NOMTCH)
      EV(NOM)=TRIAL
      GO TO 130
 200   CONTINUE
      DO 349 I=1,NEV
 349  EV(I)=EV(I+NADD)
      DO 600 I=1,NEV
      AROOT=EV(I)
      DO 240 J=1,N
 240   Y(J)=1.0
      IF(I.EQ.1) GO TO 250
      IF(ABS(EV(I-1)-AROOT).LT.TOLER) GO TO 260
 250   IA=-1
 260   IA=IA+1
      ELIM1=A(1)-AROOT
      ELIM2=W(1)
      DO 300 J=1,NN
      IF(ABS(ELIM1).LE.ABS(W(J))) GO TO 270
      TA(J)=ELIM1
      TB(J)=ELIM2
      P(J)=0.0
      TEMP=W(J)/ELIM1
      ELIM1=A(J+1)-AROOT-TEMP*ELIM2
      ELIM2=W(J+1)
      GO TO 280
 270   TA(J)=W(J)
      TB(J)=A(J+1)-AROOT
      P(J)=W(J+1)
      TEMP=1.0
      IF(ABS(W(J)).GT.THETA1) TEMP=ELIM1/W(J)
      ELIM1=ELIM2-TEMP*TB(J)
      ELIM2=-TEMP*W(J+1)
 280   B(J)=TEMP
 300   CONTINUE
      TA(N)=ELIM1
      TB(N)=0.0
      P(N)=0.0
      P(NN)=0.0
      ITER=1
      IF(IA.NE.0) GO TO 460
 320   L=N+1
      DO 400 J=1,N
      L=L-1
 330   CONTINUE
      IF(N-L-1) 340,350,360
 340   ELIM1=Y(L)
      GO TO 370
 350   ELIM1=Y(L)-Y(L+1)*TB(L)
      GOTO 370
 360   ELIM1=Y(L)-Y(L+1)*TB(L)-Y(L+2)*P(L)
 370   CONTINUE
      IF(ABS(ELIM1).GT.DELBIG) GO TO 380
      TEMP=TA(L)
      IF(ABS(TEMP).LT.DELTA) TEMP=DELTA
      Y(L)=ELIM1/TEMP
      GO TO 400
 380   DO 390 K=1,N
 390   Y(K)=Y(K)/DELBIG
      GO TO 330
 400   CONTINUE
      GO TO (410,500),ITER
 410   ITER=ITER+1
 420   ELIM1=Y(1)
      DO 450 J=1,NN
      IF(TA(J).EQ.W(J)) GO TO 440
      Y(J)=ELIM1
      ELIM1=Y(J+1)-ELIM1*B(J)
      GO TO 450
 440   Y(J)=Y(J+1)
      ELIM1=ELIM1-Y(J+1)*B(J)
 450   CONTINUE
      Y(N)=ELIM1
      GO TO 320
 460   CONTINUE
      DO 470 J=1,N
      RAND1=MOD(4099.0*RAND1,RPOWER)
 470   Y(J)=RAND1/RPOW1-1.0
      GO TO 320
 500   IF(IA.EQ.0) GO TO 550
      DO 540 J1=1,IA
      K=I-J1
      TEMP=0.0
      IPT=(K-1)*N
      DO 520 J=1,N
      IPT=IPT+1
 520   TEMP=TEMP+Y(J)*VEC(IPT)
      IPT=(K-1)*N
      DO 530 J=1,N
      IPT=IPT+1
 530   Y(J)=Y(J)-TEMP*VEC(IPT)
 540   CONTINUE
 550   GO TO(420,560),ITER
 560   ELIM1=0.0
      DO 570 J=1,N
      ABSYJ=ABS(Y(J))
 570   ELIM1=MAX(ELIM1,ABSYJ)
      TEMP=0.0
      DO 580 J=1,N
      ELIM2=Y(J)/ELIM1
      TEMP=TEMP+ELIM2*ELIM2
 580   CONTINUE
      TEMP=1.0/(SQRT(TEMP)*ELIM1)
      DO 590 J=1,N
      Y(J)=Y(J)*TEMP
      IF(ABS(Y(J)).LT.DEL1) Y(J)=0.0
 590   CONTINUE
      IPT=(I-1)*N
      DO 595 J=1,N
      IPT=IPT+1
      VEC(IPT)=Y(J)
 595   CONTINUE
 600   CONTINUE
      DO 700 I=1,NEV
      IPT=(I-1)*N
      DO 620 J=1,N
      IPT=IPT+1
      Y(J)=VEC(IPT)
 620   CONTINUE
      L=N-2
      MK=(N*(N-1))/2-3
      MK1=3
      DO 660 J=1,L
      T = 0.0
      K=N-J-1
      M = K+1
      DO 640 KK=M,N
640   T = T + DD( MK + KK ) * Y(KK)
      DO 650 KK=M,N
      EPR = T* DD( MK + KK)
650   Y(KK) = Y(KK) - EPR -EPR
      MK =MK - MK1
660   MK1 = MK1 + 1
      T=0.0
      DO 670 J=1,N
670   T=T+Y(J)*Y(J)
      XNORM = SQRT (T)
      XNORM1 = 1.0/XNORM
      DO 680 J=1,N
680   Y(J)= Y(J)*XNORM1
      IPT=(I-1)*N
      DO 690 J=1,N
      IPT=IPT+1
      VEC(IPT)=Y(J)
 690   CONTINUE
700   CONTINUE
      DO 720 I=1,N
      EV(I)=EV(I)*ANORM
 720   CONTINUE
      RETURN
      END
      SUBROUTINE LSSOLV(R,Y,W,N,X,A,M)
      implicit none
      DOUBLE PRECISION R(1),Y(1),W(1)
      INTEGER N, M
      DOUBLE PRECISION X(M),A(M,M+1)
      INTEGER MM, K, KX, J, I, JX
      DOUBLE PRECISION RJ, RK, RT
      IF(M.NE.3) CALL DIE
      MM=M+1
      DO 99999 K=1,M
      KX=M-K
      DO 99998 J=1,M
      JX=M-J
      A(J,K)=0.0
      DO 99997 I=1,N
      IF(.NOT.(JX.GT.0)) GO TO 99995
      RJ=R(I)**JX
      GO TO 99996
99995 RJ=1.0
99996 IF(.NOT.(KX.GT.0)) GO TO 99993
      RK=R(I)**KX
      GO TO 99994
99993 RK=1.0
99994 A(J,K)=W(I)*RJ*RK+A(J,K)
99997 CONTINUE
99998 CONTINUE
99999 CONTINUE
      DO 99992 J=1,M
      JX=M-J
      A(J,MM)=0.0
      DO 99991 I=1,N
      IF(.NOT.(JX.GT.0)) GO TO 99989
      RJ=R(I)**JX
      GO TO 99990
99989 RJ=1.0
99990 A(J,MM)=W(I)*RJ*Y(I)+A(J,MM)
99991 CONTINUE
99992 CONTINUE
      IF(M.NE.3) CALL DIE
      DO 70 J=1,3
      WRITE(6,65) (A(J,K),K=1,4)
  65      FORMAT(3F16.6,5X,F16.6)
  70      CONTINUE
      DO 80 I=2,3
      RT=A(I,1)/A(1,1)
      DO 76 J=1,4
      A(I,J)=A(I,J)-RT*A(1,J)
  76      CONTINUE
  80      CONTINUE
      RT=A(3,2)/A(2,2)
      DO 84 J=1,4
      A(3,J)=A(3,J)-RT*A(2,J)
  84      CONTINUE
      DO 90 I=1,2
      RT=A(I,3)/A(3,3)
      DO 86 J=1,4
      A(I,J)=A(I,J)-RT*A(3,J)
  86      CONTINUE
  90      CONTINUE
      RT=A(1,2)/A(2,2)
      DO 94 J=1,4
      A(1,J)=A(1,J)-RT*A(2,J)
  94      CONTINUE
      DO 100 J=1,3
      WRITE(6,65) (A(J,K),K=1,4)
 100      CONTINUE
      DO 99988 I=1,M
      X(I)=A(I,MM)/A(I,I)
99988 CONTINUE
      WRITE(6,66) (X(J),J=1,M)
  66  FORMAT(/3F16.6,5X,F16.6)
      END
c----------------------------------------------------------------------
      subroutine rsdch21(IUNSCD,unmess,natom,ndd4,
     .       IBLO,INBLO,DD1,natmax,INB,DD3,mxexcl,JNB,DD2,mxnonb,
     .       IDD4,JDD4,DD4,mxextr,AMASS)
c
c     Lecture matrice des derivees secondes sous forme "compressee",
c     calculee par CHARMM21.
c
c     Dimensions (declarees) des tableaux a lire:
c     IBLO(natmax), INBLO(natmax), DD1(6*natmax)
c     INB(mxexcl),  DD3(9*mxexcl)
c     JNB(mxnonb),  DD2(6*mxnonb)
c     IDD4(mxextr), JDD4(mxextr), DD4(9*mxextr)
c
c     YHS-mai-1999
c     Version amelioree de Rsdchm (test des dimensions complet).
      implicit none
c I/O:
      INTEGER natom, ndd4, IUNSCD, unmess,
     .        INBLO(*), IBLO(*), natmax, mxexcl, mxnonb, mxextr
      INTEGER*2 JNB(*),INB(*)
      INTEGER*2 IDD4(*),JDD4(*)
      REAL AMASS(*)
      REAL DD2(*),DD3(*),DD4(*)
      double precision DD1(*)
c Local:
      integer ntitmx
      parameter(ntitmx=100)
c     icntrl: dimension plus grande dans charmm.
      INTEGER icntrl(6), ntit, njnb, ninb, nbig, npbs, noat,
     .   i, j, k, ii, jj, kk
      CHARACTER*4 HDRS
      character*7 progrnm
      character*9 program
      character*12 progrer, progrwn
      CHARACTER*80 title(ntitmx)
c Begin:
      progrnm='Rsdch21'
      program=' '//progrnm//'>'
      progrer='%'//progrnm//'-Er>'
      progrwn='%'//progrnm//'-Wn>'
c
      write(unmess,'(/2A)') program,
     .' Lecture matrice CHARMM, version 21 (format compresse).'
c
      read(IUNSCD) HDRS,ICNTRL
c
      write(unmess,'(/4A,I6))') program,
     .' File header= ',HDRS,
     .' Matrix dimension: ',ICNTRL(2)
c
      NATOM=ICNTRL(3)
      write(unmess,'(A,I8,A)') program,
     .      natom,' atoms in the system studied.'
      if (natom.gt.natmax) then
          write(unmess,'(2A,I8)') progrer,
     .  ' More than the maximum allowed, i.e.: ',natmax
          stop
      endif
c
      NJNB=ICNTRL(4)
      write(unmess,'(A,I8,A)') program,
     .      njnb,' nonbonded interactions.'
      if (njnb.gt.mxnonb) then
          write(unmess,'(2A,I8)') progrer,
     .  ' More than the maximum allowed, i.e.: ',mxnonb
          stop
      endif
c
      NINB=ICNTRL(5)
      write(unmess,'(A,I8,A)') program,
     .      ninb,' excluded interactions.'
      if (ninb.gt.mxexcl) then
          write(unmess,'(2A,I8)') progrer,
     .  ' More than the maximum allowed, i.e.: ',mxexcl
          stop
      endif
c
      NDD4=ICNTRL(6)
      write(unmess,'(A,I8,A/)') program,
     .      mxextr,' extra interactions.'
      if (ndd4.gt.mxextr) then
          write(unmess,'(2A,I8)') progrer,
     .  ' More than the maximum allowed, i.e.: ',mxextr
          stop
      endif
c
      read(IUNSCD) ntit,(title(i),i=1,min(ntit,ntitmx))
      write(unmess,'(A)') (title(i),i=1,min(ntit,ntitmx))
c
      read(IUNSCD) (IBLO(I),I=1,NATOM)
      read(IUNSCD) (INBLO(I),I=1,NATOM)
      IF(NINB.GT.0) read(IUNSCD) (INB(I),I=1,NINB)
      IF(NJNB.GT.0) read(IUNSCD) (JNB(I),I=1,NJNB)
c
      write(unmess,'(A)') ' Lecture DD1...'
      read(IUNSCD) (DD1(I),I=1,6*NATOM)
c
      IF(NJNB.GT.0) then
      write(unmess,'(A)') ' Lecture DD2...'
      read(IUNSCD) (DD2(I),I=1,6*NJNB)
      endif
c
      IF(NINB.GT.0) then
      write(unmess,'(A)') ' Lecture DD3...'
      read(IUNSCD) (DD3(I),I=1,9*NINB)
      endif
c
      IF(NDD4.GT.0) then
      write(unmess,'(A)') ' Lecture DD4...'
      read(IUNSCD) (IDD4(I),I=1,NDD4)
      read(IUNSCD) (JDD4(I),I=1,NDD4)
      read(IUNSCD) (DD4(I),I=1,9*NDD4)
      endif
      write(unmess,'(A)') ' Lecture des masses...'
      read(IUNSCD) (AMASS(I),I=1,NATOM)
c
      write(unmess,'(A)') ' Tests...'
      npbs=0
      do i=1,natom
         if (IBLO(I).le.0.or.IBLO(I).gt.ninb) then
             npbs=npbs+1  
             if (npbs.lt.10) then
                 write(unmess,'(A,I6,A,I12)') 
     .         ' Atome ',i,' IBLO= ',IBLO(I)
             else if (npbs.eq.10) then
                 write(unmess,'(A)') ' ...'
             endif
         endif
      enddo
c
      if (npbs.gt.0)    
     .write(unmess,'(/A,I6,A/)') progrwn,npbs,
     .    ' gros problemes avec IBLO.'
      npbs=0
      do i=1,natom
         if (INBLO(I).le.0.or.INBLO(I).gt.njnb) npbs=npbs+1  
      enddo
      if (npbs.gt.0)    
     .write(unmess,'(/A,I6,A/)') progrwn,npbs,
     .    ' gros problemes avec INBLO.'
c
      noat=0
      do i=1,natom
         if (AMASS(I).lt.0.5.or.AMASS(I).gt.100) noat=noat+1
      enddo
      if (noat.gt.0)    
     .write(unmess,'(/A,I6,A/)') progrwn,noat,
     .    ' particules de masses non comprises entre 0.5 et 100...'
c
      nbig=0
      do i=1,6*natom
         if (dabs(DD1(I)).gt.1E+10) nbig=nbig+1
      enddo
      do i=1,6*njnb
         if (abs(DD2(I)).gt.1E+10) nbig=nbig+1
      enddo
      do i=1,9*ninb
         if (abs(DD3(I)).gt.1E+10) nbig=nbig+1
      enddo
      do i=1,9*ndd4
         if (abs(DD4(I)).gt.1E+10) nbig=nbig+1
      enddo
      write(unmess,'(A,I7,A)') program,nbig,' donnees > 1E+10.'
c
      return
      end
c
      SUBROUTINE MAKESD(NATOM,NAT3,INBLO,JNB,IBLO,INB,AMASS,
     .      DD1,DD2,DD3,NDD4,NDD4MX,DD4,IDD4,JDD4,DD5,unmess)
C
C     SETS UP THE Mass-weighted SECOND DERIVATIVE MATRIX 
C     FROM THE COMPRESSED FORM, in upper triangular form.
C
C     By Bernard R. Brooks   1982
c     Version fortran reduite (no LRAISE): YHS-Janvier-1994
      implicit none
c I/O:
      INTEGER NATOM, NAT3, NDD4, NDD4MX
      integer INBLO(*), IBLO(*)
      integer*2 INB(*), JNB(*), IDD4(*), JDD4(*)
      integer unmess
      real amass(*), dd2(*), dd3(*), dd4(*)
      double precision dd1(*), dd5(*)
c Local:
      INTEGER IPT
      INTEGER IIADD, IJADD, NB, LIM, NPR, IPTX, JPR
      INTEGER i, j, i3, j3, ii, itemp
      double precision pdr, pdx
c Begin:
c         write(6,*) 'Atomes non lies: '
c         write(6,'(10I6)') (JNB(J),J=1,inblo(natom))
c         write(6,*) 'Atomes exclus: '
c         write(6,'(10I6)') (INB(J),J=1,iblo(natom))
      IIADD=0
      IPT=1
      DO I=1,NATOM
      I3=NAT3-I*3+2
      PDR=1.d0/amass(i)
      DD5(IPT)=DD1(IIADD+1)*PDR
      DD5(IPT+1)=DD1(IIADD+2)*PDR
      DD5(IPT+2)=DD1(IIADD+4)*PDR
      IPT=IPT+I3+1
      DD5(IPT)=DD1(IIADD+3)*PDR
      DD5(IPT+1)=DD1(IIADD+5)*PDR
      IPT=IPT+I3
      DD5(IPT)=DD1(IIADD+6)*PDR
      IIADD=IIADD+6
      IPT=IPT+I3-1
      enddo
C
      ITEMP=0
      IJADD=0
      NB=0
      LIM=NATOM-1
      DO I=1,LIM
      NPR=INBLO(I)-ITEMP
      ITEMP=INBLO(I)
      IF(NPR.GT.0) then
      I3=I*3-2
      IPTX=((I3-1)*(NAT3+NAT3-I3))/2
      PDX=1.d0/sqrt(amass(i))
      DO JPR=1,NPR
      NB=NB+1
      J=JNB(NB)
      IF(J.LT.0) J=-J
      J3=J*3-2
      PDR=1.d0/sqrt(amass(j))*PDX
      DD2(IJADD+2)=DD2(IJADD+2)*PDR
      DD2(IJADD+4)=DD2(IJADD+4)*PDR
      DD2(IJADD+5)=DD2(IJADD+5)*PDR
      IPT=IPTX+J3
      DD5(IPT)=DD2(IJADD+1)*PDR
      DD5(IPT+1)=DD2(IJADD+2)
      DD5(IPT+2)=DD2(IJADD+4)
      IPT=IPT+NAT3-I3
      DD5(IPT)=DD2(IJADD+2)
      DD5(IPT+1)=DD2(IJADD+3)*PDR
      DD5(IPT+2)=DD2(IJADD+5)
      IPT=IPT+NAT3-I3-1
      DD5(IPT)=DD2(IJADD+4)
      DD5(IPT+1)=DD2(IJADD+5)
      DD5(IPT+2)=DD2(IJADD+6)*PDR
      IJADD=IJADD+6
      enddo
      endif
      enddo
C
      ITEMP=0
      IJADD=0
      NB=0
      LIM=NATOM-1
      DO I=1,LIM
      NPR=IBLO(I)-ITEMP
      ITEMP=IBLO(I)
      IF(NPR.GT.0) then
      I3=I*3-2
      IPTX=((I3-1)*(NAT3+NAT3-I3))/2
      PDX=1.d0/sqrt(amass(i))
      DO JPR=1,NPR
      NB=NB+1
      J=INB(NB)
      IF(J.LT.0) J=-J
      J3=J*3-2
      PDR=PDX*1.d0/sqrt(amass(j))
      IPT=IPTX+J3
      DD5(IPT)=DD5(IPT)+DD3(IJADD+1)*PDR
      DD5(IPT+1)=DD5(IPT+1)+DD3(IJADD+4)*PDR
      DD5(IPT+2)=DD5(IPT+2)+DD3(IJADD+7)*PDR
      IPT=IPT+NAT3-I3
      DD5(IPT)=DD5(IPT)+DD3(IJADD+2)*PDR
      DD5(IPT+1)=DD5(IPT+1)+DD3(IJADD+5)*PDR
      DD5(IPT+2)=DD5(IPT+2)+DD3(IJADD+8)*PDR
      IPT=IPT+NAT3-I3-1
      DD5(IPT)=DD5(IPT)+DD3(IJADD+3)*PDR
      DD5(IPT+1)=DD5(IPT+1)+DD3(IJADD+6)*PDR
      DD5(IPT+2)=DD5(IPT+2)+DD3(IJADD+9)*PDR
      IJADD=IJADD+9
      enddo
      endif
      enddo
C
      IJADD=0
      IF(NDD4.GT.NDD4MX) then
         write(unmess,'(2(A,I6))')
     .       '%Diag-Err: ',ndd4,
     .       ' extra-interactions. Maximum= ',ndd4mx
         stop
      endif
      DO II=1,NDD4
      I=IDD4(II)
      J=JDD4(II)
      I3=I*3-2
      J3=J*3-2
      PDR=1.d0/sqrt(amass(i)*amass(j))
      IPT=J3+((I3-1)*(NAT3+NAT3-I3))/2
      DD5(IPT)=DD5(IPT)+DD4(IJADD+1)*PDR
      DD5(IPT+1)=DD5(IPT+1)+DD4(IJADD+4)*PDR
      DD5(IPT+2)=DD5(IPT+2)+DD4(IJADD+7)*PDR
      IPT=IPT+NAT3-I3
      DD5(IPT)=DD5(IPT)+DD4(IJADD+2)*PDR
      DD5(IPT+1)=DD5(IPT+1)+DD4(IJADD+5)*PDR
      DD5(IPT+2)=DD5(IPT+2)+DD4(IJADD+8)*PDR
      IPT=IPT+NAT3-I3-1
      DD5(IPT)=DD5(IPT)+DD4(IJADD+3)*PDR
      DD5(IPT+1)=DD5(IPT+1)+DD4(IJADD+6)*PDR
      DD5(IPT+2)=DD5(IPT+2)+DD4(IJADD+9)*PDR
      IJADD=IJADD+9
      enddo
c
      return
      end
c
      SUBROUTINE MAKWSD(NATOM,NAT3,INBLO,JNB,IBLO,INB,AMASS,
     .      DD1,DD2,DD3,NDD4,NDD4MX,DD4,IDD4,JDD4,DD5,
     .      nldimx,rcreux,unmess,unwrit,qbinaire)
C
C     SETS UP THE Mass-weighted SECOND DERIVATIVE MATRIX 
C     FROM THE COMPRESSED FORM, in upper triangular form,
C     and writes it, non-zero elements being chosen within
C     pieces of length nldim in DD5...
C
C     From Makesd, By Bernard R. Brooks   1982
c     YHS-Janvier-1994
c     YHS-Octobre-1994 (tests ajoutes)
      implicit none
c I/O:
      logical qbinaire
      INTEGER NATOM, NAT3, NDD4, NDD4MX, nldimx
      integer INBLO(*), IBLO(*)
      integer*2 INB(*), JNB(*), IDD4(*), JDD4(*)
      integer unmess, unwrit
      real amass(*), dd2(*), dd3(*), dd4(*)
      double precision dd1(*), dd5(*), rcreux
c Local:
      INTEGER IPT, iptr, iptmin, iptmax, nlin, nldim
      INTEGER IIADD, IJADD, NB, LIM, NPR, IPTX, JPR
      INTEGER i, j, i3, j3, ii, itemp, nnuls, nbig, nnbig
      double precision pdr, pdx
c Begin:
      nlin=(nat3+1)*nat3/2
      nldim=nldimx-2 
c
      if (unwrit.le.0) then
        write(unmess,'(A)') '%MAKWSD-Error: no unit to write matrix.'
        return
      else
        write(unmess,'(A,I11,A,I11)')
     .     ' Makwsd: Matrice de dimension ',nlin,
     .             ' ecrite par blocs de ',nldim
      endif
c
      iptmin=0
      iptmax=nlin
      if (iptmax.gt.nldim) iptmax=nldim
c
c     Boucle: calcul des elements IPTMIN a IPTMAX,
c     de la matrice DD5.
c
      nnbig=0
      nnuls=0
 100  continue
      write(6,'(A,I12,A,I12)') 
     .    ' From element: ',iptmin+1,' To: ',iptmax
      DO I=1,nldim+2
         DD5(i)=0.d0
      enddo
c
      IIADD=0
      IPT=1
      DO I=1,NATOM
      I3=NAT3-I*3+2
      PDR=1.d0/amass(i)
      if (ipt+2.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      IF (iptr.gt.0) DD5(IPTr)=DD1(IIADD+1)*PDR
      IF (iptr+1.gt.0) DD5(IPTr+1)=DD1(IIADD+2)*PDR
      DD5(IPTr+2)=DD1(IIADD+4)*PDR
      endif
      IPT=IPT+I3+1
      if (ipt+1.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      IF (iptr.gt.0) DD5(IPTr)=DD1(IIADD+3)*PDR
      DD5(IPTr+1)=DD1(IIADD+5)*PDR
      endif
      IPT=IPT+I3
      if (ipt.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      DD5(IPTr)=DD1(IIADD+6)*PDR
      endif
      IIADD=IIADD+6
      IPT=IPT+I3-1
      enddo
C
      nbig=0
      DO I=1,nldim+2
         if(dabs(DD5(i)).gt.1E+10) nbig=nbig+1
      enddo
      if (nbig.gt.0)
     .write(unmess,'(A,I11,A)')
     .     '%Makwsd-W: DD1 => ',nbig,' elements > 1E+10.'
C
      ITEMP=0
      IJADD=0
      NB=0
      LIM=NATOM-1
c
      DO I=1,LIM
      NPR=INBLO(I)-ITEMP
      ITEMP=INBLO(I)
      IF(NPR.GT.0) then
      I3=I*3-2
      IPTX=((I3-1)*(NAT3+NAT3-I3))/2
      PDX=1.d0/sqrt(amass(i))
c
c     Paires pour l'atome i:
      DO JPR=1,NPR
      NB=NB+1
      J=JNB(NB)
      IF(J.LT.0) J=-J
      J3=J*3-2
      PDR=1.d0/sqrt(amass(j))*PDX
      IPT=IPTX+J3
      if (ipt+2.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      if (iptr.gt.0) DD5(IPTr)=DD2(IJADD+1)*PDR
      if (iptr+1.gt.0) DD5(IPTr+1)=DD2(IJADD+2)*PDR
      DD5(IPTr+2)=DD2(IJADD+4)*PDR
      endif
      IPT=IPT+NAT3-I3
      if (ipt+2.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      if (iptr.gt.0) DD5(IPTr)=DD2(IJADD+2)*PDR
      if (iptr+1.gt.0) DD5(IPTr+1)=DD2(IJADD+3)*PDR
      DD5(IPTr+2)=DD2(IJADD+5)*PDR
      endif
      IPT=IPT+NAT3-I3-1
      if (ipt+2.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      if (iptr.gt.0) DD5(IPTr)=DD2(IJADD+4)*PDR
      if (iptr+1.gt.0) DD5(IPTr+1)=DD2(IJADD+5)*PDR
      DD5(IPTr+2)=DD2(IJADD+6)*PDR
      endif
      IJADD=IJADD+6
      enddo
      endif
      enddo
C
      nbig=0
      DO I=1,nldim+2
         if(dabs(DD5(i)).gt.1E+10) nbig=nbig+1
      enddo
      if (nbig.gt.0)
     .write(unmess,'(A,I11,A)')
     .     '%Makwsd-W: DD2 => ',nbig,' elements > 1E+10.'
C
      ITEMP=0
      IJADD=0
      NB=0
      LIM=NATOM-1
      DO I=1,LIM
      NPR=IBLO(I)-ITEMP
      ITEMP=IBLO(I)
      IF(NPR.GT.0) then
      I3=I*3-2
      IPTX=((I3-1)*(NAT3+NAT3-I3))/2
      PDX=1.d0/sqrt(amass(i))
      DO JPR=1,NPR
      NB=NB+1
      J=INB(NB)
      IF(J.LT.0) J=-J
      J3=J*3-2
      PDR=PDX*1.d0/sqrt(amass(j))
      IPT=IPTX+J3
      if (ipt+2.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      if (iptr.gt.0) DD5(IPTr)=DD5(IPTr)+DD3(IJADD+1)*PDR
      if (iptr+1.gt.0) DD5(IPTr+1)=DD5(IPTr+1)+DD3(IJADD+4)*PDR
      DD5(IPTr+2)=DD5(IPTr+2)+DD3(IJADD+7)*PDR
      endif
      IPT=IPT+NAT3-I3
      if (ipt+2.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      if (iptr.gt.0) DD5(IPTr)=DD5(IPTr)+DD3(IJADD+2)*PDR
      if (iptr+1.gt.0) DD5(IPTr+1)=DD5(IPTr+1)+DD3(IJADD+5)*PDR
      DD5(IPTr+2)=DD5(IPTr+2)+DD3(IJADD+8)*PDR
      endif
      IPT=IPT+NAT3-I3-1
      if (ipt+2.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      if (iptr.gt.0) DD5(IPTr)=DD5(IPTr)+DD3(IJADD+3)*PDR
      if (iptr+1.gt.0) DD5(IPTr+1)=DD5(IPTr+1)+DD3(IJADD+6)*PDR
      DD5(IPTr+2)=DD5(IPTr+2)+DD3(IJADD+9)*PDR
      endif
      IJADD=IJADD+9
      enddo
      endif
      enddo
C
      nbig=0
      DO I=1,nldim+2
         if(dabs(DD5(i)).gt.1E+10) nbig=nbig+1
      enddo
      if (nbig.gt.0)
     .write(unmess,'(A,I11,A)')
     .     '%Makwsd-W: DD3 => ',nbig,' elements > 1E+10.'
C
      IJADD=0
      IF(NDD4.GT.NDD4MX) then
         write(unmess,'(2(A,I6))')
     .       '%Diag-Err: ',ndd4,
     .       ' extra-interactions. Maximum= ',ndd4mx
         stop
      endif
      DO II=1,NDD4
      I=IDD4(II)
      J=JDD4(II)
      I3=I*3-2
      J3=J*3-2
      PDR=1.d0/sqrt(amass(i)*amass(j))
      IPT=J3+((I3-1)*(NAT3+NAT3-I3))/2
      if (ipt+2.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      if (iptr.gt.0) DD5(IPTr)=DD5(IPTr)+DD4(IJADD+1)*PDR
      if (iptr+1.gt.0) DD5(IPTr+1)=DD5(IPTr+1)+DD4(IJADD+4)*PDR
      DD5(IPTr+2)=DD5(IPTr+2)+DD4(IJADD+7)*PDR
      endif
      IPT=IPT+NAT3-I3
      if (ipt+2.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      if (iptr.gt.0) DD5(IPTr)=DD5(IPTr)+DD4(IJADD+2)*PDR
      if (iptr+1.gt.0) DD5(IPTr+1)=DD5(IPTr+1)+DD4(IJADD+5)*PDR
      DD5(IPTr+2)=DD5(IPTr+2)+DD4(IJADD+8)*PDR
      endif
      IPT=IPT+NAT3-I3-1
      if (ipt+2.gt.iptmin.and.ipt.le.iptmax) then
      iptr=ipt-iptmin
      if (iptr.gt.0) DD5(IPTr)=DD5(IPTr)+DD4(IJADD+3)*PDR
      if (iptr+1.gt.0) DD5(IPTr+1)=DD5(IPTr+1)+DD4(IJADD+6)*PDR
      DD5(IPTr+2)=DD5(IPTr+2)+DD4(IJADD+9)*PDR
      endif
      IJADD=IJADD+9
      enddo
c
      nbig=0
      DO I=1,nldim+2
         if(dabs(DD5(i)).gt.1E+10) nbig=nbig+1
      enddo
      if (nbig.gt.0)
     .write(unmess,'(A,I11,A)')
     .     '%Makwsd-W: DD4 => ',nbig,' elements > 1E+10.'
C
c     Sortie de la matrice:
c
      iptr=0
      DO i=1,nat3
         DO j=i,nat3
            iptr=iptr+1
            if (iptr.gt.iptmin.and.
     .          dabs(dd5(iptr-iptmin)).gt.rcreux) then
                if (iptr.le.iptmax) then
                  nnuls=nnuls+1
                  if (qbinaire) then
                      write(unwrit) i, j, dd5(iptr-iptmin)
                  else
                      write(unwrit,*) i, j, dd5(iptr-iptmin)
                  endif
                  if (dabs(dd5(iptr-iptmin)).gt.1E+10) 
     .                nnbig=nnbig+1
                else
                  goto 200
                endif
            endif
         enddo
      enddo
c
 200  continue
      if (iptmax.lt.nlin) then
         iptmin=iptmin+nldim
         iptmax=iptmax+nldim
         if (iptmax.gt.nlin) iptmax=nlin
         goto 100
      endif
c
      write(unmess,'(A,I11,A,A,1PG8.2,A)')
     .    ' Makwsd: ',nnuls,' elements non-nuls ',
     .    '( zero == ',rcreux,' ). '
      write(unmess,'(A,I11,A)')
     .    ' Makwsd: ',nnbig,' elements > 1E+10.'
c
      return
      end
c----------------------------------------------------------------
      SUBROUTINE RSECF2(V,nmax,LMAT,DIMSD,nset3,IUNINP,MATORG)
C 
C     LIT (SUR IUNINP) UNE MATRICE LINEAIRE ET LA TRANSFORME EN
C     TABLEAU A DEUX DIMENSIONS
C     Simplification de RDSECF (prediag, hint*...)
C
      IMPLICIT NONE
      INTEGER IUNINP, DIMSD, NMAX
      CHARACTER*4 MATORG
      DOUBLE PRECISION LMAT(*), V(NMAX,*)
C
      logical qprt
      INTEGER ntitle, mxtitl, ii, nset3
      parameter(mxtitl=20)
      INTEGER MATDIM, NAT, NSETD, LBLOCK, NBLOCK, NDONE, I, J
      CHARACTER*4 REFHDR
      CHARACTER*80 tempt, title(mxtitl)
      DOUBLE PRECISION NSETRL, nsetr
C
      REFHDR='SECD'
      NSETD =0   
      LBLOCK=0   
C 
      READ(IUNINP,'(A)',ERR=10,END=10) tempt
      goto 20
 10   continue
      write(6,*) ' RDSECF> debut de fichier incorrect (pas grave)'
 20   continue
C
c     Une facilite... dangereuse.
c
      ntitle=6
      DO 700 J=1,NTITLE
      READ(iuninp,'(A)',ERR=690,END=690) TEMPt
 690  write(6,'(a)') tempt
      TITLE(J)=TEMPT
 700  continue
C  
      READ(IUNINP,*,ERR=105,END=105) MATDIM,NSETR,NAT,LBLOCK
      goto 115
 105  continue
      write(6,*) '%RDSECF-W: probleme de lecture. '
 115  continue
      nset3=3*nsetr
      WRITE(6,'(A,I6)') ' RDSECF: order of arrays is ',nset3
C
      IF (MATDIM.GT.DIMSD) then
      WRITE(6,'(/A,I6/A,I6/A)')
     &' %rdsecf-WARNING: The length of the read matrix is ',MATDIM,
     &'   instead of the maximum expected lenght : ',DIMSD,
     &'   Reservation of memory should have been affected ... '
      NSETRL=(SQRT(2*FLOAT(MATDIM))-0.5D0)/3
      NSETD =IDNINT(NSETRL)
      WRITE(6,'(A,F9.2)')
     &'   The correponding number of selected atoms should be:',NSETRL
      else
      write(6,*) 'RDSECF: matdim= ',matdim
      endif
      READ(IUNINP,*)
      READ(IUNINP,*)
C
      if (LBLOCK.GE.1) then
      NBLOCK=DINT(DFLOAT(MATDIM/LBLOCK))
      ELSE
      LBLOCK=MATDIM
      NBLOCK=1
      endif
      write(6,*) 'RDSECF: nblock= ',nblock
C
      WRITE(6,'(A,I6,A)')
     &' rdsecf: Reading by blocks of ',LBLOCK,' datas '
C
      DO 800 I=1,NBLOCK
      NDONE=(I-1)*LBLOCK
      READ(IUNINP,*,err=999,end=890) (LMAT(NDONE+J),J=1,LBLOCK)
 800  continue
      NDONE=NBLOCK*LBLOCK
      IF (MATDIM-NDONE.GT.0) then
      READ(IUNINP,*,err=999,end=890) (LMAT(NDONE+J),J=1,MATDIM-NDONE)
      endif
C
      goto 895
 890  continue
      write(6,*) 'RDSECF: fin du fichier rencontree...'
      write(6,*) 'RDSECF: Nblock= ',i,' Ndone= ',ndone,' element ',j  
      WRITE(6,'(A,I6,A)')
     &' rdsecf: ',ndone+j,' elements lus.'
 895  continue
c
      if (matorg.ne.'LOWE') then
      write(6,*) ' %RDSECF-Error: matorg= ',matorg
      stop
      endif
      if (3*nsetr.gt.nmax) then
      write(6,*) ' %RDSECF-Error: N matrice lu= ',3*nsetr
      stop
      endif
C
      write(6,*) 'RDSECF: matorg= ',matorg
      II=0
      do 900 i=1,3*nsetr
      DO 990 J=1,I
      II=II+1
      V(I,J)=LMAT(II)
      V(J,I)=LMAT(II)
 990  continue
 900  continue
C
      RETURN
 999  continue
      write(6,*) 'RDSECF: Erreur de lecture. Ndone = ',ndone,' element ',j  
      write(6,*) (Lmat(NDONE+J),J=1,LBLOCK)
      stop
      END
      subroutine DIE
      write(6,*) '%DIAGQ-Err: Big problem. Sorry.'
      stop
      end
